/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef __CAM_COMMON_AE_API_H__
#define __CAM_COMMON_AE_API_H__

#include "cam_common_api.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define CAM_COMMON_AE T_DATABASE_AUTO_EXPOSURE_3
typedef TDatabaseAutoExposure_3_t CamCommonAe_t;

RESULT VsiCamCommonAeLoadConfig
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonAeSetState
(
    CamCommonHandle_t hCamCommon,
    bool_t            enable
);

RESULT VsiCamCommonAeGetMode
(
    CamCommonHandle_t      hCamCommon,
    CamDeviceAeWorkMode_t  *mode
);

RESULT VsiCamCommonRegisterAeLib
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonUnRegisterAeLib
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonAeRangeCheck
(
    CamCommonHandle_t    hCamCommon
);

#ifdef __cplusplus
}
#endif

#endif    // __CAM_COMMON_AE_API_H__
