/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef __CAM_COMMON_AWB_API_H__
#define __CAM_COMMON_AWB_API_H__

#include "cam_common_api.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define CAM_COMMON_AWB T_DATABASE_AUTO_WHITE_BALANCE_3
typedef TDatabaseAutoWhiteBalance_3_t CamCommonAwb_t;

RESULT VsiCamCommonAwbLoadConfig
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonAwbSetState
(
    CamCommonHandle_t   hCamCommon,
    bool_t              enable
);

RESULT VsiCamCommonAwbGetMode
(
    CamCommonHandle_t       hCamCommon,
    CamDeviceAwbWorkMode_t  *mode
);

RESULT VsiCamCommonImageSetMetadata
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonRegisterAwbLib
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonUnRegisterAwbLib
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonAwbRangeCheck
(
    CamCommonHandle_t    hCamCommon
);
#ifdef __cplusplus
}
#endif

#endif    // __CAM_COMMON_AWB_API_H__
