/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef __CAM_COMMON_CALIB_API_H__
#define __CAM_COMMON_CALIB_API_H__

#include <cam_device/cam_device_calibration.h>
#include <cam_device/cam_device_api.h>
#include "cam_common_api.h"

#ifdef __cplusplus
extern "C"
{
#endif

/**
 * @defgroup cam_common_api Cam common api Definitions
 * @{
 *
 *
 */

/*****************************************************************************/
/**
 * @brief   This function loads the calibration parameters into the database of
 *          software stack.
 *
 * @param   hCamDevice          Handle to the CamDevice instance.
 * @param   defCalibIllum       Select the default illumination when pipeline is
 *                              connected.
 * @param   pTDbCalibCfg        Configuration structure for calibration parameter.
 *
 * @retval  RET_SUCCESS         Operation succeeded
 * @retval  RET_FAILURE         General failure
 *
 *****************************************************************************/
RESULT VsiCamCommonLoadCalibration
(
    CamCommonHandle_t        *hDatabase,
    CamDeviceHandle_t         hCamDevice,
    CamDeviceCalibIllumType_t defCalibIllum
);

 /* @} cam_common_api */


#ifdef __cplusplus
}
#endif

#endif    // __CAM_COMMON_CALIB_API_H__
