/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef __CAM_COMMON_WDR_API_H__
#define __CAM_COMMON_WDR_API_H__

#include "cam_common_api.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define CAM_COMMON_WDR_MANUAL T_DATABASE_WIDE_DYNAMIC_RANGE_4
#define CAM_COMMON_WDR_AUTO T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_4

RESULT VsiCamCommonWdrLoadConfig
(
    CamCommonHandle_t  hCamCommon,
    CamDeviceHandle_t  hCamDevice
);

RESULT VsiCamCommonWdrSetState
(
    CamCommonHandle_t     hCamCommon,
    bool_t                enable,
    CamDeviceConfigMode_t configMode
);

RESULT VsiCamCommonWdrGetProperties
(
    CamDeviceHandle_t    hCamDevice
);

RESULT VsiCamCommonWdrRangeCheck
(
    CamCommonHandle_t    hCamCommon
);
#ifdef __cplusplus
}
#endif

#endif    // __CAM_COMMON_WDR_API_H__
