/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef COMMON_H
#define COMMON_H

/**
 * @file common.h
 *
 * @brief
 *
 *****************************************************************************/
/**
 * @page module_name_page Module Name
 * Describe here what this module does.
 *
 * For a detailed list of functions and implementation detail refer to:
 * - @ref module_name
 *
 * @defgroup COMMON module
 * @{
 *
 */
#include <ebase/types.h>
#include <common/return_codes.h>

#ifdef __cplusplus
extern "C"
{
#endif

typedef enum ARunMode_e
{
    INVALID_MODE                    = 0,        /**< initialization value */
    MANUAL_MODE                     = 1,        /**< run manual cproc*/
    AUTO_MODE                       = 2,        /**< run auto cproc */
    MAX_MODE
} ARunMode_t;

typedef enum ASensorMode_e {
    ASENSOR_MODE_LINEAR = 0,
    ASENSOR_MODE_HDR,
    ASENSOR_MODE_NATIVE_HDR,
    ASENSOR_MODE_MAX
} ASensorMode_t;


#define ESPINON6 0.000001 //this should put into an common file later because it be called at many files
#define AUTO_NUM 20
RESULT paramInterpolate(float32_t inGain, float32_t *pGxTable, float32_t *pGyTable, uint8_t binNum, float32_t *pOutParam);
RESULT paramInterpolateMatrix(float32_t inGain, float32_t *pGxTable, float32_t **pGyTable, uint8_t num, uint8_t binNum, float32_t *pOutParam);
RESULT paramInterpolateMatrix2(float32_t inGain, float32_t *pGxTable, float32_t *pGyTable, uint8_t xNum, uint8_t yNum, uint8_t binNum, float32_t *pOutParam);
bool_t classifyVector(float32_t *pGxTable, float32_t **pGyTable, float32_t vaule, uint8_t xNum, uint8_t yNum, float32_t *pOutParam);
bool_t classifyMatrix(float32_t *pGxTable, float32_t ***pGyTable, float32_t vaule, uint8_t xNum, uint8_t yNum, uint8_t zNum, float32_t **pOutParam);
bool_t isFloatParamInRange(float32_t a, float32_t b);
bool_t isIncrease(const float32_t* pGains, uint8_t autoLevel);

#ifdef __cplusplus
}
#endif


/* @} Cproc */


#endif /* CPROC_H*/
