/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef __SYSTEM_MODULE_H__
#define __SYSTEM_MODULE_H__

#include <ebase/types.h>

typedef enum IspSystemPortType_e
{
    ISP_SYSTEM_PORT_TYPE_INVALID = 0,
    ISP_SYSTEM_PORT_TYPE_INPUT   = 1,
    ISP_SYSTEM_PORT_TYPE_OUTPUT  = 2,
    ISP_SYSTEM_PORT_TYPE_MAX
} IspSystemPortType_t;

typedef enum IspSystemBufferType_e
{
    ISP_SYSTEM_BUFFER_TYPE_INVALID = 0,
    ISP_SYSTEM_BUFFER_TYPE_EMPTY   = 1,
    ISP_SYSTEM_BUFFER_TYPE_FULL    = 2,
    ISP_SYSTEM_BUFFER_TYPE_MAX
} IspSystemBufferType_t;

typedef struct IspSystemPortInfo_s
{
    IspSystemPortType_t     portType;
    IspSystemBufferType_t   bufferType;
    uint8_t                 portId;
} IspSystemPortInfo_t;

typedef RESULT (* IspSystemEnqueueBuf_t)
(
    void                    *pHandle,
    void                    *pModuleHandle,
    IspSystemPortInfo_t     *pPortInfo,
    void                    *pMediaBuf
);

typedef RESULT (* IspSystemDequeueBuf_t)
(
    void                    *pHandle,
    void                    *pModuleHandle,
    IspSystemPortInfo_t     *pPortInfo,
    void                    **pMediaBuf
);


#endif  // __CAMERA_DEVICE_BUF_DEFS_H__
