/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef ISPCMDBUFFER_H
#define ISPCMDBUFFER_H
#include "types.h"
//#include "IspCmdBufferDev.h"

RESULT CmdBufferCreate(IspCmdBufferHandle_t hIspCmdBuffer);
RESULT CmdBufferDestory(IspCmdBufferHandle_t hIspCmdBuffer);

RESULT CmdBufferDefValStore(IspCmdBufferHandle_t hIspCmdBuffer);
RESULT CmdBufferDefValInit(IspCmdBufferHandle_t hIspCmdBuffer);
RESULT CmdBufferReadTbl(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t *val);
RESULT CmdBufferReadReg(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t *val);
RESULT CmdBufferWriteTbl(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t val);
RESULT CmdBufferWriteReg(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t val);

RESULT CmdBufferUpdateRunBuffer(IspCmdBufferHandle_t hIspCmdBuffer,bool pingpongFlag);
RESULT CmdBufferReadRunReg(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t *val);
RESULT CmdBufferWriteRunReg(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t val);

RESULT CmdBufferWriteBackStatus(IspCmdBufferHandle_t hIspCmdBuffer);

void CmdBufferRegDump(IspCmdBufferRegBuffer_t *refreshRegs,uint32_t frameid,uint32_t devid);

RESULT CmdBufferBatchCreate(IspCmdBufferHandle_t hIspCmdBuffer);
RESULT CmdBufferBatchDestory(IspCmdBufferHandle_t hIspCmdBuffer);
RESULT CmdBufferBatchDefValInit(IspCmdBufferHandle_t hIspCmdBuffer);
RESULT CmdBufferBatchWriteReg(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t *pVal);
RESULT CmdBufferBatchWriteRunReg(IspCmdBufferHandle_t hIspCmdBuffer, uint32_t offset, uint32_t *pVal);
RESULT CmdBufferBatchUpdateRunBuffer(IspCmdBufferHandle_t hIspCmdBuffer, bool pingpongFlag);
RESULT CmdBufferBatchSyncCtrlReg(IspCmdBufferHandle_t hIspCmdBuffer);

#endif /*_CMDBUFFER_H_*/
