/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2024 */

#pragma once

#include "common_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct TCommonBuffer {
  void *pBegin;
  size_t size;
  void *pUserData;

  bool isAllocated;
} TCommonBuffer_t;

int TCommonBuffer_clear(TCommonBuffer_t *pBuffer);

int TCommonBuffer_create(TCommonBuffer_t **ppBuffer);

int TCommonBuffer_delete(TCommonBuffer_t **ppBuffer);

int TCommonBuffer_duplicate(TCommonBuffer_t const *pBuffer,
                            TCommonBuffer_t **ppBuffer2);

int TCommonBuffer_load2(char const *pFilename, size_t offset, size_t size,
                        TCommonBuffer_t *pBuffer);

#define TCommonBuffer_load(pFilename, pBuffer)                                 \
  TCommonBuffer_load2(pFilename, 0, 0, pBuffer);

int TCommonBuffer_save2(TCommonBuffer_t *pBuffer, char const *pFilename,
                        size_t offset);

#define TCommonBuffer_save(pBuffer, pFilename)                                 \
  TCommonBuffer_save2(pBuffer, pFilename, 0);

#ifdef __cplusplus
}
#endif
