/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "common_base.h"

#include "common_buffer.h"
#include "common_dqueue.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef uintptr_t TCommonBufferQueueHandle_t;

typedef struct {
  TCommonDQueueDeleteDataHandler_t *pDeleteBufferHandler;
} TCommonBufferQueueOpenParam_t;

int TCommonBufferQueue_open(TCommonBufferQueueOpenParam_t *pParam,
                            TCommonBufferQueueHandle_t *pHandle);

int TCommonBufferQueue_close(TCommonBufferQueueHandle_t *pHandle);

size_t TCommonBufferQueue_inputLength(TCommonBufferQueueHandle_t handle);

int TCommonBufferQueue_inputPop(TCommonBufferQueueHandle_t handle,
                                TCommonBuffer_t **ppBuffer, ssize_t timeoutMs);

int TCommonBufferQueue_inputPush(TCommonBufferQueueHandle_t handle,
                                 TCommonBuffer_t **ppBuffer);

size_t TCommonBufferQueue_outputLength(TCommonBufferQueueHandle_t handle);

int TCommonBufferQueue_outputPop(TCommonBufferQueueHandle_t handle,
                                 TCommonBuffer_t **ppBuffer, ssize_t timeoutMs);

int TCommonBufferQueue_outputPush(TCommonBufferQueueHandle_t handle,
                                  TCommonBuffer_t **ppBuffer);

#ifdef __cplusplus
}
#endif
