/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "common_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef uintptr_t TCommonDQueueHandle_t;

typedef int TCommonDQueueDeleteDataHandler_t(void **ppData);

typedef struct {
  TCommonDQueueDeleteDataHandler_t *pDeleteDataHandler;
  bool isThreadSafe;
} TCommonDQueueOpenParam_t;

int TCommonDQueue_open(TCommonDQueueOpenParam_t *pParam,
                       TCommonDQueueHandle_t *pHandle);

int TCommonDQueue_close(TCommonDQueueHandle_t *pHandle);

int TCommonDQueue_cleanup(TCommonDQueueHandle_t handle);

int TCommonDQueue_back(TCommonDQueueHandle_t handle, void **ppData);

int TCommonDQueue_front(TCommonDQueueHandle_t handle, void **ppData);

size_t TCommonDQueue_length(TCommonDQueueHandle_t handle);

int TCommonDQueue_pushBack(TCommonDQueueHandle_t handle, void **ppData);

int TCommonDQueue_pushFront(TCommonDQueueHandle_t handle, void **ppData);

int TCommonDQueue_popBack(TCommonDQueueHandle_t handle, void **ppData);

int TCommonDQueue_popFront(TCommonDQueueHandle_t handle, void **ppData);

#ifdef __cplusplus
}
#endif
