/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "common_base.h"

#ifdef __cplusplus
extern "C" {
#endif

#define RET_SUCCESS 0             // this has to be 0, if clauses rely on it
#define RET_FAILURE 1             // general failure
#define RET_NOT_SUPPORT 2         // feature not supported
#define RET_BUSY 3                // there's already something going on...
#define RET_CANCELED 4            // operation canceled
#define RET_OUT_OF_MEMORY 5       // out of memory
#define RET_OUT_OF_RANGE 6        // parameter/value out of range
#define RET_IDLE 7                // feature/subsystem is in idle state
#define RET_WRONG_HANDLE 8        // handle is wrong
#define RET_NULL_POINTER 9        // parameter(s) is a(are) NULL pointer(s)
#define RET_NOT_AVAILABLE 10      // profile not available
#define RET_DIVISION_BY_ZERO 11   // a divisor equals ZERO
#define RET_WRONG_STATE 12        // state machine in wrong state
#define RET_INVALID_PARM 13       // invalid parameter
#define RET_PENDING 14            // command pending
#define RET_WRONG_CONFIG 15       // given configuration is invalid
#define RET_TIMEOUT 16            // wait time out
#define RET_UNSUPPORTED_ID 0xFFFF // un-support index number

char const *TCommonError_text(int error);

#ifdef __cplusplus
}
#endif
