/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "common_base.h"

#include "common_error.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef uintptr_t TCommonLoggerHandle_t;

typedef struct {
  bool isFifo;
} TCommonLoggerOpenParam_t;

int TCommonLogger_open(TCommonLoggerOpenParam_t *pParam,
                       TCommonLoggerHandle_t *pHandle);

int TCommonLogger_close(TCommonLoggerHandle_t *pHandle);

int TCommonLogger_messageGet(TCommonLoggerHandle_t handle, char **ppText);

int TCommonLogger_messageSet(TCommonLoggerHandle_t handle, char **ppText);

#if defined(LOGGER)
#undef LOGGER
#endif // LOGGER

#define LOGGER(format, ...)                                                    \
  do {                                                                         \
    char *pText = TCommonStdlib_calloc(1, 300);                                \
    if (!pText) {                                                              \
      return RET_OUT_OF_MEMORY;                                                \
    };                                                                         \
    sprintf(pText, format, ##__VA_ARGS__);                                     \
    int r = TCommonLogger_messageSet(pContext->openParam.hLogger, &pText);     \
    REPORT(r);                                                                 \
  } while (0)

#ifdef __cplusplus
}
#endif
