/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2024 */

#pragma once

#include "common_base.h"

#include "common_task.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef int TCommonSessionLoopHandler_t(uintptr_t hDriver, size_t count);

typedef int TCommonSessionStateHandler_t(void *pUserData, bool isRunning);

typedef struct {
  size_t expect;
  size_t total;
  size_t success;
} TCommonSessionLoopCount_t;

typedef struct {
  char description[30];
  TCommonSessionLoopCount_t loopCount;
  TCommonSessionLoopHandler_t *pLoopHandler;
  TCommonSessionStateHandler_t *pStateHandler;
  TCommonTaskHandle_t hTask;
  bool isRunning;
  void *pUserData;
} TCommonSession_t;

#ifdef __cplusplus
}
#endif
