/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "common_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef uintptr_t TCommonTaskHandle_t;

#if defined(FREERTOS)
typedef int32_t TCommonTaskReturn_t;
#else
typedef void *TCommonTaskReturn_t;
#endif // FREERTOS

typedef TCommonTaskReturn_t TCommonTaskRoutine_t(void *pParam);

typedef struct {
  bool isFreeRun;
  TCommonTaskRoutine_t *pRoutine;
  void *pUserData;
} TCommonTaskOpenParam_t;

int TCommonTask_open(TCommonTaskOpenParam_t *pParam,
                     TCommonTaskHandle_t *pHandle);

int TCommonTask_close(TCommonTaskHandle_t *pHandle);

#ifdef __cplusplus
}
#endif
