/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "common_base.h"

#if defined(FREERTOS)
#include <freertos/freertos_time.h>
#endif // FREERTOS

#if defined(LINUX)
#include <linux/linux_time.h>
#endif // LINUX

#if defined(WIN32)
#include <win32/win32_time.h>
#endif // WIN32

#ifdef __cplusplus
extern "C" {
#endif

time_t TCommonTime_timespecDiffNs(struct timespec *pEnd,
                                  struct timespec *pBegin);

time_t TCommonTime_timespecToMs(struct timespec *pTs);

void TCommonTime_sleepSinceMs(struct timespec *pSince, time_t ms);

char *TCommonTime_timestampWithFormat(char *pBuffer, size_t size,
                                      char const *pFormat);

char *TCommonTime_timestamp(char *pBuffer, size_t size);

char *TCommonTime_timestamp2(char *pBuffer, size_t size);

#ifdef __cplusplus
}
#endif
