/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2024 */

#pragma once

#include "common_base.h"

#include <ff.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef FIL TCommonStdioFile_t;

TCommonStdioFile_t *TCommonStdio_fopen(char const *pFilename,
                                       char const *pFlag);

int TCommonStdio_fclose(TCommonStdioFile_t *pFile);

size_t TCommonStdio_fread(void *pBuffer, size_t size, size_t count,
                          TCommonStdioFile_t *pFile);

size_t TCommonStdio_fwrite(void *pBuffer, size_t size, size_t count,
                           TCommonStdioFile_t *pFile);

int TCommonStdio_flush(TCommonStdioFile_t *pFile);

int TCommonStdio_fseek(TCommonStdioFile_t *pFile, long offset, int whence);

long TCommonStdio_ftell(TCommonStdioFile_t *pFile);

char *TCommonStdio_fgets(char *s, int n, TCommonStdioFile_t *pFile);

#define TCommonStdio_fprintf f_printf

void TCommonStdio_rewind(TCommonStdioFile_t *pFile);

int TCommonStdio_remove(char const *pPath);

int TCommonStdio_rename(char const *pPath, char const *pPathNew);

#define TCommonStdio_stderr NULL

#define TCommonStdio_stdout NULL

TCommonStdioFile_t *TCommonStdio_open_memStream(char **ppBufferToBeFree,
                                                size_t *pBufferSize,
                                                char *pFilename,
                                                size_t filenameSize);

int TCommonStdio_close_memStream(TCommonStdioFile_t *pFile,
                                 char **ppBufferToBeFree, size_t *pBufferSize,
                                 char *pFilename, size_t filenameSize);

#ifdef __cplusplus
}
#endif
