/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool lumaCtrolEnable;

  uint8_t preGammaStrength;
  uint8_t strength;
  float sigma;
  uint8_t sigmaRange;

  uint16_t lumaCurveX[12];
  uint16_t lumaCurveY[12];

  float blendStatic;
  float blendMotion;
  float blendSlope;
  uint16_t sigmaOffset;

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabase2DNoiseReduction_5_2_t;

int TDatabase2DNoiseReduction_5_2_parse(
    TJsonValue_t *pValue, TDatabase2DNoiseReduction_5_2_t *pConfig);

int TDatabase2DNoiseReduction_5_2_serialize(
    TDatabase2DNoiseReduction_5_2_t *pConfig, TJsonValue_t *pValue);

int TDatabase2DNoiseReduction_5_2_reset(
    TDatabase2DNoiseReduction_5_2_t *pConfig);

#ifdef __cplusplus
}
#endif
