/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float blendStatic;
  float blendMotion;
  float blendSlope;
  float vstFactor;
  float sigmaScale[3];
  float sigmaFactorMul[3];
  uint16_t sigmaFactorMotionMax;
  uint16_t sigmaFactorMotionMin;

  uint16_t sigmaOffset;

  uint16_t staticDetailThresh[2][3];
  uint16_t staticDetailBoostThresh[2][3];
  float staticDetailBoost[2][3];
  uint16_t staticDetailClipThresh[2][3];

  uint16_t movingDetailThresh[2][3];
  uint16_t movingDetailBoostThresh[2][3];
  float movingDetailBoost[2][3];
  uint16_t movingDetailClipThresh[2][3];

  float staticFactor[3];

  uint16_t lumaCurveCfgAryX[12];
  uint16_t lumaCurveCfgAryY[12];
  uint16_t lumaCurveCfgAryPx[12];
  bool lumaCurveCfgInterpMode;
  bool isLumaCtrl;

  uint16_t lscCompCurveCfgAryX[12];
  uint16_t lscCompCurveCfgAryY[12];
  uint16_t lscCompCurveCfgAryPx[12];
  bool lscCompCurveCfgInterpMode;
  bool isLscGainComp;

  uint16_t motionMotionAnchorX[2];
  uint16_t motionCfgCurveAryX[12];
  uint16_t motionCfgCurveAryY[12];
  uint16_t motionCfgCurveAryPx[12];
  bool motionCfgCurveInterpMode;
  bool isMotionCtrl;

  DEPRECATED_MSG("use 'lumaCurveCfgAryX' instead")
  uint16_t lumaCurveX[12];
  DEPRECATED_MSG("use 'lumaCurveCfgAryY' instead")
  uint16_t lumaCurveY[12];
  DEPRECATED_MSG("use 'lumaCurveCfgAryPx' instead")
  uint16_t lumaCurvePx[12];

  DEPRECATED_MSG("use 'lscCompCurveCfgAryX' instead")
  uint16_t lscCompCurveX[12];
  DEPRECATED_MSG("use 'lscCompCurveCfgAryY' instead")
  uint16_t lscCompCurveY[12];
  DEPRECATED_MSG("use 'lscCompCurveCfgAryPx' instead")
  uint16_t lscCompCurvePx[12];

  DEPRECATED_MSG("use 'motionMotionAnchorX' instead")
  uint16_t motionAnchorX[2];
  DEPRECATED_MSG("use 'motionCfgCurveAryX' instead")
  uint16_t motionFactorCurveX[12];
  DEPRECATED_MSG("use 'motionCfgCurveAryY' instead")
  uint16_t motionFactorCurveY[12];
  DEPRECATED_MSG("use 'motionCfgCurveAryPx' instead")
  uint16_t motionFactorCurvePx[12];

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabase2DNoiseReduction_6_t;

int TDatabase2DNoiseReduction_6_parse(TJsonValue_t *pValue,
                                      TDatabase2DNoiseReduction_6_t *pConfig);

int TDatabase2DNoiseReduction_6_serialize(
    TDatabase2DNoiseReduction_6_t *pConfig, TJsonValue_t *pValue);

int TDatabase2DNoiseReduction_6_reset(TDatabase2DNoiseReduction_6_t *pConfig);

#ifdef __cplusplus
}
#endif
