/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint8_t strength;
  int32_t motionInv;
  uint16_t delta;

  bool motionDetectRoiEnable[64];

  uint16_t detectorX0[64];
  uint16_t detectorX1[64];
  uint16_t detectorY0[64];
  uint16_t detectorY1[64];

  DEPRECATED_MSG("use 'motionDetectRoiEnable' instead") bool isDetector[64];

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabase3DNoiseReduction_2_4_t;

int TDatabase3DNoiseReduction_2_4_parse(
    TJsonValue_t *pValue, TDatabase3DNoiseReduction_2_4_t *pConfig);

int TDatabase3DNoiseReduction_2_4_serialize(
    TDatabase3DNoiseReduction_2_4_t *pConfig, TJsonValue_t *pValue);

int TDatabase3DNoiseReduction_2_4_reset(
    TDatabase3DNoiseReduction_2_4_t *pConfig);

#ifdef __cplusplus
}
#endif
