/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float dilateH;

  float filterLen;
  float filterLen2;

  float noiseLevel;

  float preWeight;
  float rangeH;
  float rangeV;
  float sadWeight;
  uint8_t strength;
  float thrMotionSlope;
  float blendMotion;
  float blendSlope;
  float blendStatic;
  float sigma;

  float noisemodelA;
  float noisemodelB;
  // uint16_t fixCurveStart;

  bool motionDilateEn;
  bool motionErodeEn;

  bool preGammaEn;
  bool nlmEn;
  bool tnrEn;

  DEPRECATED_MSG("use noisemodelA instead") float noiseModelA;
  DEPRECATED_MSG("use noisemodelB instead") float noiseModelB;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabase3DNoiseReduction_3_t;

int TDatabase3DNoiseReduction_3_parse(TJsonValue_t *pValue,
                                      TDatabase3DNoiseReduction_3_t *pConfig);

int TDatabase3DNoiseReduction_3_serialize(
    TDatabase3DNoiseReduction_3_t *pConfig, TJsonValue_t *pValue);

int TDatabase3DNoiseReduction_3_reset(TDatabase3DNoiseReduction_3_t *pConfig);

#ifdef __cplusplus
}
#endif
