/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint8_t dilateH;
  float filterLen;
  float filterLen2;
  float noiseLevel;

  uint8_t preWeight;
  uint8_t rangeH;
  uint8_t rangeV;
  uint8_t sadWeight;
  uint8_t strength;
  uint16_t thrMotionSlope;

  float blendMotion;
  float blendSlope;
  float blendStatic;
  float sigma;

  float noiseModelA;
  float noiseModelB;
  uint16_t noiseModeFixCurveStart;

  bool preGammaEn;

  bool motionDilateEn;
  bool motionErodeEn;

  bool nlmEn;
  bool tnrEn;

  DEPRECATED_MSG("use enable instead") bool isEnable;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabase3DNoiseReduction_3_1_t;

int TDatabase3DNoiseReduction_3_1_parse(
    TJsonValue_t *pValue, TDatabase3DNoiseReduction_3_1_t *pConfig);

int TDatabase3DNoiseReduction_3_1_serialize(
    TDatabase3DNoiseReduction_3_1_t *pConfig, TJsonValue_t *pValue);

int TDatabase3DNoiseReduction_3_1_reset(
    TDatabase3DNoiseReduction_3_1_t *pConfig);

#ifdef __cplusplus
}
#endif
