/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  double vstFactor;
  uint8_t tnrStrength;
  uint8_t tnrStrength2;
  uint8_t filterLen;
  uint8_t filterLen2;
  double motionSmoothFactor;
  uint8_t rangeH;
  uint8_t sadWeight;
  bool diffType;
  uint8_t sqrDiffFactor;
  uint8_t motionSmoothLvl;
  uint8_t dilateH;
  uint16_t noiseLevel;
  uint16_t thrMotionSlope;
  uint16_t tnrLumaCurveX[12];
  uint16_t tnrLumaCurveY[12];
  uint16_t tnrMotionSlopY[12];

  uint8_t inputBits;
  uint16_t fixCurveStart;
  double noisemodelA;
  double noisemodelB;
  uint32_t blsExp[4];

  bool isMotionDilate;
  bool isGammaFeBe;
  bool isGaussBlur;

  DEPRECATED_MSG("use motionSmoothLvl instead") uint8_t motionSmoothLevel;
  DEPRECATED_MSG("use tnrMotionSlopY instead") uint16_t tnrMotionSlopeY[12];
  DEPRECATED_MSG("use noisemodelA instead") double noiseModelA;
  DEPRECATED_MSG("use noisemodelB instead") double noiseModelB;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabase3DNoiseReduction_4_t;

int TDatabase3DNoiseReduction_4_parse(TJsonValue_t *pValue,
                                      TDatabase3DNoiseReduction_4_t *pConfig);

int TDatabase3DNoiseReduction_4_serialize(
    TDatabase3DNoiseReduction_4_t *pConfig, TJsonValue_t *pValue);

int TDatabase3DNoiseReduction_4_reset(TDatabase3DNoiseReduction_4_t *pConfig);

#ifdef __cplusplus
}
#endif
