/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  uint8_t strength[20];
  float sigma[20];
  int32_t preGammaEn[20];

  DEPRECATED_MSG("use 'preGammaEn' instead") uint8_t preGamma[20];

  SIMULATOR bool hdr;
} TDatabaseAuto2DNoiseReduction_3_Table_t;

typedef struct {
  bool enable;

  TDatabaseAuto2DNoiseReduction_3_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAuto2DNoiseReduction_3_t;

int TDatabaseAuto2DNoiseReduction_3_parse(
    TJsonValue_t *pValue, TDatabaseAuto2DNoiseReduction_3_t *pConfig);

int TDatabaseAuto2DNoiseReduction_3_serialize(
    TDatabaseAuto2DNoiseReduction_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAuto2DNoiseReduction_3_reset(
    TDatabaseAuto2DNoiseReduction_3_t *pConfig);

#ifdef __cplusplus
}
#endif
