/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain[20];
  float sigma[20];
  uint8_t strength[20];
  uint8_t preGammaStrength[20];
  uint16_t lumaCurveX[20][12];
  uint16_t lumaCurveY[20][12];

  SIMULATOR bool hdr;

  DEPRECATED_MSG("use 'gain' instead") float gains[20];
} TDatabaseAuto2DNoiseReduction_5_2_Table_t;

typedef struct {
  bool enable;

  TDatabaseAuto2DNoiseReduction_5_2_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAuto2DNoiseReduction_5_2_t;

int TDatabaseAuto2DNoiseReduction_5_2_parse(
    TJsonValue_t *pValue, TDatabaseAuto2DNoiseReduction_5_2_t *pConfig);

int TDatabaseAuto2DNoiseReduction_5_2_serialize(
    TDatabaseAuto2DNoiseReduction_5_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAuto2DNoiseReduction_5_2_reset(
    TDatabaseAuto2DNoiseReduction_5_2_t *pConfig);

#ifdef __cplusplus
}
#endif
