/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Cao, Zheng since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain[20];
  float vstFactor[20];
  float blendStatic[20];
  float blendMotion[20];
  float blendSlope[20];
  uint16_t sigmaOffset[20];
  uint16_t lumaCurveY[20][12];
  uint16_t lscCompCurveY[20][12];
  uint16_t motionFacCurveY[20][12];
  uint16_t motionAnchorX[20][2];
  uint16_t staticDetailThresh[20][2][3];
  uint16_t staticDetailBoostThresh[20][2][3];
  float staticDetailBoost[20][2][3];
  uint16_t movingDetailClipThresh[20][2][3];
  uint16_t movingDetailThresh[20][2][3];
  uint16_t movingDetailBoostThresh[20][2][3];
  float movingDetailBoost[20][2][3];
  uint16_t staticDetailClipThresh[20][2][3];
  float sigmaScale[20][3];
  float staticFactor[20][3];
  float sigmaFactorMul[20][3];
  uint16_t sigmaFactorMotionMax[20];

  DEPRECATED_MSG("use 'gain' instead") float gains[20];

  SIMULATOR bool hdr;
} TDatabaseAuto2DNoiseReduction_6_Table_t;

typedef struct {
  bool enable;

  TDatabaseAuto2DNoiseReduction_6_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAuto2DNoiseReduction_6_t;

int TDatabaseAuto2DNoiseReduction_6_parse(
    TJsonValue_t *pValue, TDatabaseAuto2DNoiseReduction_6_t *pConfig);

int TDatabaseAuto2DNoiseReduction_6_serialize(
    TDatabaseAuto2DNoiseReduction_6_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAuto2DNoiseReduction_6_reset(
    TDatabaseAuto2DNoiseReduction_6_t *pConfig);

#ifdef __cplusplus
}
#endif
