/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  uint8_t strength[20];
  int32_t motionInv[20];
  uint16_t delta[20];

  uint8_t motionDilateEn[20];
  uint16_t updateTemporal[20];
  uint16_t strengthCurveTemporal[20];
  uint16_t temporalCurve[20][17];
  uint8_t rangeT[20];

  SIMULATOR bool hdr;
} TDatabaseAuto3DNoiseReduction_2_1_Table_t;

typedef struct {
  bool enable;

  TDatabaseAuto3DNoiseReduction_2_1_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAuto3DNoiseReduction_2_1_t;

int TDatabaseAuto3DNoiseReduction_2_1_parse(
    TJsonValue_t *pValue, TDatabaseAuto3DNoiseReduction_2_1_t *pConfig);

int TDatabaseAuto3DNoiseReduction_2_1_serialize(
    TDatabaseAuto3DNoiseReduction_2_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAuto3DNoiseReduction_2_1_reset(
    TDatabaseAuto3DNoiseReduction_2_1_t *pConfig);

#ifdef __cplusplus
}
#endif
