/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  float filterLen[20];
  float filterLen2[20];
  float noiseLevel[20];
  float thrMotionSlope[20];

  uint8_t sadWeight[20];

  bool motionDilateEn[20];
  bool motionErodeEn[20];
  bool pregammaEn[20];

  uint8_t strength[20];
  uint8_t rangeH[20];
  uint8_t rangeV[20];
  uint16_t dilateH[20];
  float preWeight[20];

  float sigma[20];
  float blendStatic[20];
  float blendMotion[20];
  float blendSlope[20];

  DEPRECATED_MSG("use pregammaEn instead") bool preGammaEn[20];

  SIMULATOR bool hdr;
} TDatabaseAuto3DNoiseReduction_3_Table_t;

typedef struct {
  bool enable;

  TDatabaseAuto3DNoiseReduction_3_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  LEGACY TDatabaseState_t *pState;
  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAuto3DNoiseReduction_3_t;

int TDatabaseAuto3DNoiseReduction_3_parse(
    TJsonValue_t *pValue, TDatabaseAuto3DNoiseReduction_3_t *pConfig);

int TDatabaseAuto3DNoiseReduction_3_serialize(
    TDatabaseAuto3DNoiseReduction_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAuto3DNoiseReduction_3_reset(
    TDatabaseAuto3DNoiseReduction_3_t *pConfig);

#ifdef __cplusplus
}
#endif
