/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Li, Renji since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float nmK;
  float nmP;
  float gains[20];
  uint16_t fixCurveStart[20];
  double noisemodelA[20];
  double noisemodelB[20];
  uint32_t blsExp[20][4];
  uint8_t tnrStrength[20];
  uint8_t tnrStrength2[20];
  uint8_t filterLen[20];
  uint8_t filterLen2[20];
  double motionSmoothFactor[20];
  uint16_t rangeH[20];
  uint8_t sadWeight[20];
  uint8_t sqrDiffFactor[20];
  uint8_t motionSmoothLvl[20];
  bool motionDilateEn[20];
  uint16_t dilateH[20];
  uint16_t tnrLumaCurveY[20][12];
  uint16_t tnrMotionSlopY[20][12];

  DEPRECATED_MSG("use noisemodelA instead") double noiseModelA[20];
  DEPRECATED_MSG("use noisemodelB instead") double noiseModelB[20];
  DEPRECATED_MSG("use tnrMotionSlopY instead") uint16_t tnrMotionSlopeY[20][12];

  SIMULATOR bool hdr;
} TDatabaseAuto3DNoiseReduction_4_Table_t;

typedef struct {
  bool enable;

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;
  TDatabaseAuto3DNoiseReduction_4_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAuto3DNoiseReduction_4_t;

int TDatabaseAuto3DNoiseReduction_4_parse(
    TJsonValue_t *pValue, TDatabaseAuto3DNoiseReduction_4_t *pConfig);

int TDatabaseAuto3DNoiseReduction_4_serialize(
    TDatabaseAuto3DNoiseReduction_4_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAuto3DNoiseReduction_4_reset(
    TDatabaseAuto3DNoiseReduction_4_t *pConfig);

#ifdef __cplusplus
}
#endif
