/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint32_t bls[20][4];
  float gains[20];

  SIMULATOR bool hdr;
} TDatabaseAutoBlackLevelSubtractionTable_t;

typedef struct {
  bool enable;

  TDatabaseAutoBlackLevelSubtractionTable_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;
  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoBlackLevelSubtraction_t;

int TDatabaseAutoBlackLevelSubtraction_parse(
    TJsonValue_t *pValue, TDatabaseAutoBlackLevelSubtraction_t *pConfig);

int TDatabaseAutoBlackLevelSubtraction_serialize(
    TDatabaseAutoBlackLevelSubtraction_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoBlackLevelSubtraction_reset(
    TDatabaseAutoBlackLevelSubtraction_t *pConfig);

#ifdef __cplusplus
}
#endif
