/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  bool cnrEnable[20];
  uint8_t cnrStrength[20];
  uint8_t cnrStrength2[20];
  uint8_t textureMask[20];
  float cSigmaLayer0[20];
  float cSigmaLayer1[20];
  float cSigmaLayer2[20];
  float cSigmaLayer3[20];

  bool ynrEnable[20];
  float ySigma[20];
  uint8_t ynrStrength[20];
  uint8_t ynrStrength2[20];

  bool hdr;

  DEPRECATED_MSG("use cSigmaLayer0 instead") float cSigmaLayer[20];
} TDatabaseAutoColorNoiseReduction_2_1_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoColorNoiseReduction_2_1_Table_t
      tables[T_DATABASE_AUTO_TABLE_SUM];

  DEPRECATED_MSG("use enable instead") bool isEnable;

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoColorNoiseReduction_2_1_t;

int TDatabaseAutoColorNoiseReduction_2_1_parse(
    TJsonValue_t *pValue, TDatabaseAutoColorNoiseReduction_2_1_t *pConfig);

int TDatabaseAutoColorNoiseReduction_2_1_serialize(
    TDatabaseAutoColorNoiseReduction_2_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoColorNoiseReduction_2_1_reset(
    TDatabaseAutoColorNoiseReduction_2_1_t *pConfig);

#ifdef __cplusplus
}
#endif
