/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  float contrast[20];
  float bright[20];
  float saturation[20];
  float hue[20];

  bool hdr;
} TDatabaseAutoColorProcess_1_2_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoColorProcess_1_2_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoColorProcess_1_2_t;

int TDatabaseAutoColorProcess_1_2_parse(
    TJsonValue_t *pValue, TDatabaseAutoColorProcess_1_2_t *pConfig);

int TDatabaseAutoColorProcess_1_2_serialize(
    TDatabaseAutoColorProcess_1_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoColorProcess_1_2_reset(
    TDatabaseAutoColorProcess_1_2_t *pConfig);

#ifdef __cplusplus
}
#endif
