/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  bool dmscSharpenEnable[20];
  bool dmscDePurpleEnable[20];
  uint16_t dmscSharpenFactorBlack[20];
  uint16_t dmscSharpenFactorWhite[20];
  uint16_t dmscSharpenClipBlack[20];
  uint16_t dmscSharpenClipWhite[20];
  uint16_t dmscSharpenT1[20];
  uint8_t dmscSharpenT2Shift[20];
  uint16_t dmscSharpenT3[20];
  uint8_t dmscSharpenT4Shift[20];
  uint8_t dmscDenoiseStrength[20];
  uint8_t dmscSharpenSize[20];
  uint16_t dmscSharpenR1[20];
  uint16_t dmscSharpenR2[20];
  uint16_t dmscSharpenR3[20];
  uint8_t dmscDepurpleSatShrink[20];
  uint8_t dmscDepurpleCbcrMode[20];
  uint8_t dmscDepurpleThr[20];
  bool hdr;

  DEPRECATED_MSG("use dmscDenoiseStrength instead") uint8_t deNoiseStrength[20];
  DEPRECATED_MSG("use dmscDepurpleCbcrMode instead")
  uint8_t dePurpleCbCrMode[20];
  DEPRECATED_MSG("use dmscDepurpleSatShrink instead")
  uint8_t dePurpleSatShrink[20];
  DEPRECATED_MSG("use dmscDepurpleThr instead") uint8_t dePurpleThr[20];
  DEPRECATED_MSG("use dmscSharpenClipBlack instead")
  uint16_t sharpenClipBlack[20];
  DEPRECATED_MSG("use dmscSharpenClipWhite instead")
  uint16_t sharpenClipWhite[20];
  DEPRECATED_MSG("use dmscSharpenFactorBlack instead")
  uint16_t sharpenFactorBlack[20];
  DEPRECATED_MSG("use dmscSharpenFactorWhite instead")
  uint16_t sharpenFactorWhite[20];
  DEPRECATED_MSG("use dmscSharpenR1 instead") uint16_t sharpenR1[20];
  DEPRECATED_MSG("use dmscSharpenR2 instead") uint16_t sharpenR2[20];
  DEPRECATED_MSG("use dmscSharpenR3 instead") uint16_t sharpenR3[20];
  DEPRECATED_MSG("use dmscSharpenSize instead") uint8_t sharpenSize[20];
  DEPRECATED_MSG("use dmscSharpenT1 instead") uint16_t sharpenT1[20];
  DEPRECATED_MSG("use dmscSharpenT2Shift instead")
  uint8_t sharpenT2Shift[20];
  DEPRECATED_MSG("use dmscSharpenT3 instead") uint16_t sharpenT3[20];
  DEPRECATED_MSG("use dmscSharpenT4Shift instead")
  uint8_t sharpenT4Shift[20];
} TDatabaseAutoDeMosaic_2_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoDeMosaic_2_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoDeMosaic_2_t;

int TDatabaseAutoDeMosaic_2_parse(TJsonValue_t *pValue,
                                  TDatabaseAutoDeMosaic_2_t *pConfig);

int TDatabaseAutoDeMosaic_2_serialize(TDatabaseAutoDeMosaic_2_t *pConfig,
                                      TJsonValue_t *pValue);

int TDatabaseAutoDeMosaic_2_reset(TDatabaseAutoDeMosaic_2_t *pConfig);

#ifdef __cplusplus
}
#endif
