/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Cao, Zheng since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

// typedef struct {
//   uint16_t layerT1;
//   uint8_t layerT2Shift;
//   uint16_t layer0T3;
//   uint8_t layerT4Shift;
//   uint16_t layerR1;
//   uint16_t layerR2;
//   uint16_t layerR3;
// } TDatabaseAutoDeMosaic_3_SharpenCurve_t;

typedef struct {
  bool hdr;
  float gains[20];
  uint8_t interpDirStrength[20][4];
  uint8_t interpLargeStr[20][2];
  bool declineEn[20];
  uint16_t highlightTh[20][2];

  bool dmscDepurpleEnable[20];
  uint8_t dmscDepurpleThr[20];
  uint8_t dmscDepurpleSatShrink[20];
  uint8_t dmscDepurpleCbCrRange[20][8];

  uint8_t sharpenCfgDeNoiseStrength[20];

  bool dmscSharpenEnable[20];
  uint16_t dmscSharpenFactor[20][6];
  uint16_t dmscSharpenClip[20][6];
  uint16_t dmscSharpenCurve0[20][7];
  uint16_t dmscSharpenCurve1[20][7];
  uint16_t dmscSharpenCurve2[20][7];
} TDatabaseAutoDeMosaic_3_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoDeMosaic_3_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED uint16_t sharpenCurve0Idx;
  RESERVED uint16_t sharpenCurve1Idx;
  RESERVED uint16_t sharpenCurve2Idx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoDeMosaic_3_t;

int TDatabaseAutoDeMosaic_3_parse(TJsonValue_t *pValue,
                                  TDatabaseAutoDeMosaic_3_t *pConfig);

int TDatabaseAutoDeMosaic_3_serialize(TDatabaseAutoDeMosaic_3_t *pConfig,
                                      TJsonValue_t *pValue);

int TDatabaseAutoDeMosaic_3_reset(TDatabaseAutoDeMosaic_3_t *pConfig);

#ifdef __cplusplus
}
#endif
