/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  float gradient[20];
  float offset[20];
  float min[20];
  float div[20];
  float sigmaG[20];
  float sigmaRb[20];
  float noiseCurve[20][17];

  bool hdr;
} TDatabaseAutoDeNoisePreFilterTable_t;

typedef struct {
  bool enable;

  TDatabaseAutoDeNoisePreFilterTable_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoDeNoisePreFilter_t;

int TDatabaseAutoDeNoisePreFilter_parse(
    TJsonValue_t *pValue, TDatabaseAutoDeNoisePreFilter_t *pConfig);

int TDatabaseAutoDeNoisePreFilter_serialize(
    TDatabaseAutoDeNoisePreFilter_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoDeNoisePreFilter_reset(
    TDatabaseAutoDeNoisePreFilter_t *pConfig);

#ifdef __cplusplus
}
#endif
