/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  uint8_t eeStrength[20];
  uint8_t eeSrcStrength[20];
  uint32_t eeYUpGain[20];
  uint32_t eeYDownGain[20];
  uint16_t eeUVGain[20];
  uint32_t eeEdgeGain[20];

  SIMULATOR bool hdr;
} TDatabaseAutoEdgeEnhance_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoEdgeEnhance_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoEdgeEnhance_t;

int TDatabaseAutoEdgeEnhance_parse(TJsonValue_t *pValue,
                                   TDatabaseAutoEdgeEnhance_t *pConfig);

int TDatabaseAutoEdgeEnhance_serialize(TDatabaseAutoEdgeEnhance_t *pConfig,
                                       TJsonValue_t *pValue);

int TDatabaseAutoEdgeEnhance_reset(TDatabaseAutoEdgeEnhance_t *pConfig);

int TDatabaseAutoEdgeEnhance_dataChanged(TDatabaseAutoEdgeEnhance_t *pConfig);

#ifdef __cplusplus
}
#endif
