/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  uint8_t eeStrength[20];
  uint8_t eeSrcStrength[20];
  uint32_t eeYUpGain[20];
  uint32_t eeYDownGain[20];
  uint16_t eeUVGain[20];
  uint32_t eeEdgeGain[20];
  bool caEnable[20];
  uint16_t caCurve[20][65];
  bool dciEnable[20];
  uint16_t dciCurve[20][65];

  SIMULATOR bool hdr;

  DEPRECATED_MSG("use eeEdgeGain instead") uint32_t edgeGain[20];
  DEPRECATED_MSG("use eeSrcStrength instead") uint8_t srcStrength[20];
  DEPRECATED_MSG("use eeStrength instead") uint8_t strength[20];
  DEPRECATED_MSG("use eeUVGain instead") uint16_t uvGain[20];
  DEPRECATED_MSG("use eeYDownGain instead") uint32_t yDownGain[20];
  DEPRECATED_MSG("use eeYUpGain instead") uint32_t yUpGain[20];
  // DEPRECATED_MSG("use caEnable instead") bool caEnable[20];
  // DEPRECATED_MSG("use dciEnable instead") bool dciEnable[20];
} TDatabaseAutoEdgeEnhance_2_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoEdgeEnhance_2_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;
  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoEdgeEnhance_2_t;

int TDatabaseAutoEdgeEnhance_2_parse(TJsonValue_t *pValue,
                                     TDatabaseAutoEdgeEnhance_2_t *pConfig);

int TDatabaseAutoEdgeEnhance_2_serialize(TDatabaseAutoEdgeEnhance_2_t *pConfig,
                                         TJsonValue_t *pValue);

int TDatabaseAutoEdgeEnhance_2_reset(TDatabaseAutoEdgeEnhance_2_t *pConfig);

int TDatabaseAutoEdgeEnhance_2_dataChanged(
    TDatabaseAutoEdgeEnhance_2_t *pConfig);

#ifdef __cplusplus
}
#endif
