/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Li, Renji since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  bool eeEnable[20];
  uint8_t eeStrength[20];
  uint16_t eeSrcStrength[20];
  uint16_t eeSrcStrengthSkin[20];

  uint8_t edgeNrLvl[20];
  uint8_t detailLvl[20];
  uint16_t detailPreEnhanceStr[20];

  uint8_t skinProcEn[20];
  uint8_t skinDetectStr[20];
  int16_t skinThr[20][6];

  uint16_t hfMergeCurve[20][4];
  uint16_t hfMergeCurveSkin[20][4];

  uint16_t gradTh[20][2];
  uint16_t gradThSkin[20][2];

  uint8_t sharpCurveLvl[20];
  uint8_t sharpskinCurveLvl[20];
  uint16_t sharpGain[20][2];
  uint16_t sharpGainSkin[20][2];
  uint8_t sharpGainUv[20];
  uint16_t sharpLimt[20][2];
  uint16_t sharpLimitSkin[20][2];

  bool depurpleEn[20];
  uint16_t depfLimit[20][4];
  uint16_t depfDetectLumaTh[20];
  uint16_t depfDetectLumaDiff[20];
  uint16_t depfCompLumaDiff[20];
  uint16_t depfSatStr[20];
  uint16_t depfFixStr[20];

  bool caEnable[20];
  uint16_t lutChromaTbl[20][65];
  bool dciEnable[20];
  uint16_t dciCurve[20][65];
  bool hdr;

  DEPRECATED_MSG("use gains instead") float anchor1[20];
  DEPRECATED_MSG("use lutChromaTbl instead") uint16_t caCurve[20][65];
  DEPRECATED_MSG("use sharpLimt instead") uint16_t sharpLimit[20][2];
  DEPRECATED_MSG("use sharpskinCurveLvl instead") uint8_t sharpSkinCurveLvl[20];
} TDatabaseAutoEdgeEnhance_3_Table_t;

typedef struct {
  bool enable;
  TDatabaseAutoEdgeEnhance_3_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoEdgeEnhance_3_t;

int TDatabaseAutoEdgeEnhance_3_parse(TJsonValue_t *pValue,
                                     TDatabaseAutoEdgeEnhance_3_t *pConfig);

int TDatabaseAutoEdgeEnhance_3_serialize(TDatabaseAutoEdgeEnhance_3_t *pConfig,
                                         TJsonValue_t *pValue);

int TDatabaseAutoEdgeEnhance_3_reset(TDatabaseAutoEdgeEnhance_3_t *pConfig);

int TDatabaseAutoEdgeEnhance_3_dataChanged(
    TDatabaseAutoEdgeEnhance_3_t *pConfig);

#ifdef __cplusplus
}
#endif
