/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float setPoint;
  float tolerance;
  float dampOver;
  float dampUnder;

  float dampUnderRatio;
  float dampUnderGain;
  float dampOverRatio;
  float dampOverGain;

  float motionFilter;
  float motionThr;
  float targetFilter;

  float lowlightLinearRepress[8];

  float lowlightLinearGain[8];
  uint32_t lowlightLinearLevel;
  float lowlightHdrRepress[8];

  float lowlightHdrGain[8];
  uint32_t lowlightHdrLevel;

  float wdrContrastMin;
  float wdrContrastMax;
  bool frameCalEnable;
  bool autoHdrEnable;
  float expv2WindowWeight[1024];

  uint8_t roiNum;
  float roiWeight;
  float roiWindow[25][5];

  uint16_t antiFlickerMode;
  uint16_t semMode;

  uint16_t mode;
  float userDefinedPeriodus;

  DEPRECATED_MSG("use roiNum instead") uint8_t roiNumber;
  DEPRECATED_MSG("use expv2WindowWeight instead") float expV2WindowWeight[1024];
  DEPRECATED_MSG("use lowlightHdrGain instead") float lowLightHdrGain[8];
  DEPRECATED_MSG("use lowlightHdrLevel instead") uint32_t lowLightHdrLevel;
  DEPRECATED_MSG("use lowlightHdrRepress instead") float lowLightHdrRepress[8];
  DEPRECATED_MSG("use lowlightLinearGain instead") float lowLightLinearGain[8];
  DEPRECATED_MSG("use lowlightLinearLevel instead")
  uint32_t lowLightLinearLevel;
  DEPRECATED_MSG("use lowlightLinearRepress instead")
  float lowLightLinearRepress[8];

  LEGACY TDatabaseState_t *pState;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoExposure_3_t;

int TDatabaseAutoExposure_3_parse(TJsonValue_t *pValue,
                                  TDatabaseAutoExposure_3_t *pConfig);

int TDatabaseAutoExposure_3_serialize(TDatabaseAutoExposure_3_t *pConfig,
                                      TJsonValue_t *pValue);

int TDatabaseAutoExposure_3_reset(TDatabaseAutoExposure_3_t *pConfig);

#ifdef __cplusplus
}
#endif
