/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint32_t data[4096];
  uint16_t type;
} TDatabaseAutoExposureStatistics_2_Statistics_t;

typedef struct {
  uint8_t blue;
  uint8_t greenBlue;
  uint8_t greenRed;
  uint8_t red;
} TDatabaseAutoExposureStatistics_2_Weight_t;

typedef struct {
  bool enable;

  uint16_t inputSelect;
  float ratio;
  TDatabaseRectangle_t rectangle;
  TDatabaseAutoExposureStatistics_2_Statistics_t statistics;

  LEGACY TDatabaseState_t *pState;
  // TDatabaseAutoExposureStatistics_2_Weight_t weight;
} TDatabaseAutoExposureStatistics_2_t;

int TDatabaseAutoExposureStatistics_2_parse(
    TJsonValue_t *pValue, TDatabaseAutoExposureStatistics_2_t *pConfig);

int TDatabaseAutoExposureStatistics_2_serialize(
    TDatabaseAutoExposureStatistics_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoExposureStatistics_2_reset(
    TDatabaseAutoExposureStatistics_2_t *pConfig);

int TDatabaseAutoExposureStatistics_2_statistics(
    TDatabaseAutoExposureStatistics_2_t *pConfig, TJsonValue_t *pValue);

#ifdef __cplusplus
}
#endif
