/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float weightWindow[3];
  float cStableTolerance;
  uint8_t cPointsOfCurve;
  float focalFilter[5];
  float shapFilter[5];
  uint16_t maxFocal;
  uint16_t minFocal;
  float cMotionThr;
  float focalStableThr;

  float cMseTolerance;
  float cPdConfThr;
  int32_t pdFocal[48];
  int32_t pdDistance;
  float pdShiftThr;
  uint8_t pdStableCountMax;

  uint16_t mode;
  uint16_t pdRoiIdx;

  DEPRECATED_MSG("use shapFilter instead") float shapeFilter[5];

  LEGACY TDatabaseState_t *pState;

  // simulator section
  char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoFocus_3_t;

int TDatabaseAutoFocus_3_parse(TJsonValue_t *pValue,
                               TDatabaseAutoFocus_3_t *pConfig);

int TDatabaseAutoFocus_3_serialize(TDatabaseAutoFocus_3_t *pConfig,
                                   TJsonValue_t *pValue);

int TDatabaseAutoFocus_3_reset(TDatabaseAutoFocus_3_t *pConfig);

#ifdef __cplusplus
}
#endif
