/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float weightWindow[9];
  float cStableTolerance;
  uint8_t cPointsOfCurve;
  uint16_t maxFocal;
  uint16_t minFocal;
  float cMotionThr;
  uint8_t uphillAllowance;
  uint8_t downhillAllowance;

  float cPdConfThr;
  float pdShiftThr;
  uint8_t pdStableCountMax;

  float pdafUnlockThreshold;

  uint8_t pcdafHybrCfgDefocusFrameNum;
  uint8_t pcdafHybrCfgLossConfFrameNum;
  uint8_t pcdafHybrCfgAccuFocusStep;
  bool pcdafHybrCfgAccFocusEn;

  uint16_t mode;
  uint8_t pdRoiIdx;

  uint8_t afmV11RoiNum;
  float afmV11RoiWeight;
  uint16_t afmV11RoiWindow[25][4];
  float afmV11RoiWindowWeight;
  float afmV3WeightWindow[225];

  DEPRECATED_MSG("use pcdafHybrCfgDefocusFrameNum instead")
  uint8_t deFocusFrameNum;

  LEGACY TDatabaseState_t *pState;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoFocus_4_t;

int TDatabaseAutoFocus_4_parse(TJsonValue_t *pValue,
                               TDatabaseAutoFocus_4_t *pConfig);

int TDatabaseAutoFocus_4_serialize(TDatabaseAutoFocus_4_t *pConfig,
                                   TJsonValue_t *pValue);

int TDatabaseAutoFocus_4_reset(TDatabaseAutoFocus_4_t *pConfig);

#ifdef __cplusplus
}
#endif
