/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint32_t sharpnessA;
  uint32_t sharpnessB;
  uint32_t sharpnessC;

  uint32_t luminanceA;
  uint32_t luminanceB;
  uint32_t luminanceC;

  uint32_t pixelCntA;
  uint32_t pixelCntB;
  uint32_t pixelCntC;

  uint16_t id;
  uint16_t window[4];

  uint32_t threshold;

  DEPRECATED_MSG("use id instead") uint16_t windowId;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoFocusMeasurement_t;

int TDatabaseAutoFocusMeasurement_parse(
    TJsonValue_t *pValue, TDatabaseAutoFocusMeasurement_t *pConfig);

int TDatabaseAutoFocusMeasurement_serialize(
    TDatabaseAutoFocusMeasurement_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoFocusMeasurement_reset(
    TDatabaseAutoFocusMeasurement_t *pConfig);

#ifdef __cplusplus
}
#endif
