/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint32_t threshold;
  uint16_t windowId;
  uint16_t instanceId;
  uint16_t window[4];

  uint32_t sharpnessA; /**< Sharpness of window A */
  uint32_t sharpnessB; /**< Sharpness of window B */
  uint32_t sharpnessC; /**< Sharpness of window C */

  uint32_t luminanceA; /**< Luminance of window A */
  uint32_t luminanceB; /**< Luminance of window B */
  uint32_t luminanceC; /**< Luminance of window C */

  uint32_t pixelCntA; /**< Pixel counts of window A */
  uint32_t pixelCntB; /**< Pixel counts of window B */
  uint32_t pixelCntC; /**< Pixel counts of window C */

  uint32_t sharpnessA1; /**< Sharpness of window A1 */
  uint32_t sharpnessB1; /**< Sharpness of window B1 */
  uint32_t sharpnessC1; /**< Sharpness of window C1 */

  uint32_t luminanceA1; /**< Luminance of window A1 */
  uint32_t luminanceB1; /**< Luminance of window B1 */
  uint32_t luminanceC1; /**< Luminance of window C1 */

  uint32_t pixelCntA1; /**< Pixel counts of window A1 */
  uint32_t pixelCntB1; /**< Pixel counts of window B1 */
  uint32_t pixelCntC1; /**< Pixel counts of window C1 */

  uint32_t sharpnessA2; /**< Sharpness of window A2 */
  uint32_t sharpnessB2; /**< Sharpness of window B2 */
  uint32_t sharpnessC2; /**< Sharpness of window C2 */

  uint32_t luminanceA2; /**< Luminance of window A2 */
  uint32_t luminanceB2; /**< Luminance of window B2 */
  uint32_t luminanceC2; /**< Luminance of window C2 */

  uint32_t pixelCntA2; /**< Pixel counts of window A2 */
  uint32_t pixelCntB2; /**< Pixel counts of window B2 */
  uint32_t pixelCntC2; /**< Pixel counts of window C2 */

  DEPRECATED_MSG("use instanceId instead") uint16_t windowInstanceId;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoFocusMeasurement_1_1_t;

int TDatabaseAutoFocusMeasurement_1_1_parse(
    TJsonValue_t *pValue, TDatabaseAutoFocusMeasurement_1_1_t *pConfig);

int TDatabaseAutoFocusMeasurement_1_1_serialize(
    TDatabaseAutoFocusMeasurement_1_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoFocusMeasurement_1_1_reset(
    TDatabaseAutoFocusMeasurement_1_1_t *pConfig);

#ifdef __cplusplus
}
#endif
