/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint8_t firHighPass[3];
  uint8_t firLowPass[3];
  uint8_t iirHighPass[3];
  uint8_t iirLowPass[3];
} TDatabaseAutoFocusMeasurement_3_Coring_t;

typedef struct {
  uint8_t dataShift;
  float highPassWeight;
  float lowPassWeight;
} TDatabaseAutoFocusMeasurement_3_Fir_t;

typedef struct {
  uint8_t dataShift;
  float highPassWeight;
  float highPassCoeff[3][4];
  float lowPassWeight;
  float lowPassCoeff[3][4];
} TDatabaseAutoFocusMeasurement_3_Iir_t;

typedef struct {
  uint32_t histDataHigh[225];
  uint32_t histDataLow[225];
  uint32_t sharpnessPassHigh[225];
  uint32_t sharpnessPassLow[225];
} TDatabaseAutoFocusMeasurement_3_Statistics_t;

typedef struct {
  uint8_t firHighPassX[4];
  float firHighPassY[3];
  uint8_t firLowPassX[4];
  float firLowPassY[3];
  uint8_t iirHighPassX[4];
  float iirHighPassY[3];
  uint8_t iirLowPassX[4];
  float iirLowPassY[3];
} TDatabaseAutoFocusMeasurement_3_Ldg_t;

typedef struct {
  bool enable;

  uint16_t bls;
  uint8_t histThr;
  float gammaVal;
  uint16_t hwRoi[4];
  TDatabaseAutoFocusMeasurement_3_Ldg_t ldg;
  TDatabaseAutoFocusMeasurement_3_Coring_t coring;
  TDatabaseAutoFocusMeasurement_3_Iir_t iir;
  TDatabaseAutoFocusMeasurement_3_Fir_t fir;

  TDatabaseAutoFocusMeasurement_3_Statistics_t statistics;
  uint32_t version;

  DEPRECATED_MSG("use gammaVal instead") float gamma;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoFocusMeasurement_3_t;

int TDatabaseAutoFocusMeasurement_3_parse(
    TJsonValue_t *pValue, TDatabaseAutoFocusMeasurement_3_t *pConfig);

int TDatabaseAutoFocusMeasurement_3_serialize(
    TDatabaseAutoFocusMeasurement_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoFocusMeasurement_3_reset(
    TDatabaseAutoFocusMeasurement_3_t *pConfig);

int TDatabaseAutoFocusMeasurement_3_statistics(
    TDatabaseAutoFocusMeasurement_3_t *pConfig, TJsonValue_t *pValue);

#ifdef __cplusplus
}
#endif
