/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain[20];
  uint16_t curve[20][64];
  bool hdr;

  DEPRECATED_MSG("use gain instead") float gains[20];
} TDatabaseAutoGammaCorrection_2_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoGammaCorrection_2_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoGammaCorrection_2_t;

int TDatabaseAutoGammaCorrection_2_parse(
    TJsonValue_t *pValue, TDatabaseAutoGammaCorrection_2_t *pConfig);

int TDatabaseAutoGammaCorrection_2_serialize(
    TDatabaseAutoGammaCorrection_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoGammaCorrection_2_reset(
    TDatabaseAutoGammaCorrection_2_t *pConfig);

#ifdef __cplusplus
}
#endif
