/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint16_t gtmCurveMode;
  bool curveCfgUserCurveEn;

  uint8_t histContrastLimitLevel;
  uint8_t histLumaThrLog[4];
  uint16_t histLumaWeight[4];
  float histHlcFactor;
  float histLumaPresWeight;
  float histCompressWeight;
  float histMaxGain;
  float histMinGain;
  float histStrength;
  float histDampCoef;
} TDatabaseAutoGlobalToneMappingCurveInfoConfig_t;

typedef struct {
  float gain[20];
  uint8_t blackWhiteCorCfgMinLog[20];
  uint8_t blackWhiteCorCfgMaxLog[20];
  uint8_t histContrastLimitLevel[20];
  float histHlcFactor[20];
  float histLumaPreserveWeight[20];
  float histMaxGain[20];
  float histMinGain[20];
  float histStrength[20][20];

  uint8_t colorWeiCfgGtmColorWeight[20][3];
  uint16_t histLumaWeight[20][4];
  uint32_t curveCfgUserCurve[20][129];

  uint8_t edrLevel;
  float edr[20];

  DEPRECATED_MSG("use 'gain' instead") float gains[20];
  DEPRECATED_MSG("use 'blackWhiteCorCfgMinLog' instead")
  uint8_t bwCorMinLog[20];
  DEPRECATED_MSG("use 'blackWhiteCorCfgMaxLog' instead")
  uint8_t bwCorMaxLog[20];
  DEPRECATED_MSG("use 'colorWeiCfgGtmColorWeight' instead")
  uint8_t gtmColorWeight[20][3];
  DEPRECATED_MSG("use 'curveCfgUserCurve' instead") uint32_t userCurve[20][129];

  SIMULATOR bool hdr;
} TDatabaseAutoGlobalToneMappingTable_t;

typedef struct {
  bool enable;

  TDatabaseAutoGlobalToneMappingTable_t tables[T_DATABASE_AUTO_TABLE_SUM];

  TDatabaseAutoGlobalToneMappingCurveInfoConfig_t gtmCurveInfo;

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoGlobalToneMapping_t;

int TDatabaseAutoGlobalToneMapping_parse(
    TJsonValue_t *pValue, TDatabaseAutoGlobalToneMapping_t *pConfig);

int TDatabaseAutoGlobalToneMapping_serialize(
    TDatabaseAutoGlobalToneMapping_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoGlobalToneMapping_reset(
    TDatabaseAutoGlobalToneMapping_t *pConfig);

#ifdef __cplusplus
}
#endif
