/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  bool motionEnableLs[20];
  bool motionEnableLsvs[20];
  uint16_t motionWeightLs[20];
  uint16_t motionWeightLsvs[20];
  uint16_t motionLowerThrLs[20];
  uint16_t motionUpperThrLs[20];
  uint16_t motionLowerThrLsvs[20];
  uint16_t motionUpperThrLsvs[20];
  uint16_t darkLowerThrLs[20];
  uint16_t darkUpperThrLs[20];
  uint16_t darkLowerThrLsvs[20];
  uint16_t darkUpperThrLsvs[20];
  bool dpfEnable[3][20];
  float dpfGradient[3][20];
  float dpfOffset[3][20];
  float dpfMin[3][20];
  float dpfDiv[3][20];
  float dpfSigmaG[3][20];
  float dpfSigmaRb[3][20];
  float dpfCurve[3][17][20];
  bool hdr;
} TDatabaseAutoHighDynamicRange_3_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoHighDynamicRange_3_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoHighDynamicRange_3_t;

int TDatabaseAutoHighDynamicRange_3_parse(
    TJsonValue_t *pValue, TDatabaseAutoHighDynamicRange_3_t *pConfig);

int TDatabaseAutoHighDynamicRange_3_serialize(
    TDatabaseAutoHighDynamicRange_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoHighDynamicRange_3_reset(
    TDatabaseAutoHighDynamicRange_3_t *pConfig);

#ifdef __cplusplus
}
#endif
