/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Cao, Zheng since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gains[20];
  float strength[20];
  bool hdr;
} TDatabaseAutoLensShadingCorrection_4_Table_t;

typedef struct {
  bool enable;

  float damping;
  uint16_t interMode;

  TDatabaseAutoLensShadingCorrection_4_Table_t
      tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoLensShadingCorrection_4_t;

int TDatabaseAutoLensShadingCorrection_4_parse(
    TJsonValue_t *pValue, TDatabaseAutoLensShadingCorrection_4_t *pConfig);

int TDatabaseAutoLensShadingCorrection_4_serialize(
    TDatabaseAutoLensShadingCorrection_4_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoLensShadingCorrection_4_reset(
    TDatabaseAutoLensShadingCorrection_4_t *pConfig);

#ifdef __cplusplus
}
#endif
