/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  bool useDamping;

  uint8_t roiNum;
  float roiWeight;
  float roiWindow[25][5];

  uint16_t mode;
  float awbTemWeight[7];

  DEPRECATED_MSG("use roiNum instead") uint8_t roiNumber;

  LEGACY TDatabaseState_t *pState;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoWhiteBalance_3_t;

int TDatabaseAutoWhiteBalance_3_parse(TJsonValue_t *pValue,
                                      TDatabaseAutoWhiteBalance_3_t *pConfig);

int TDatabaseAutoWhiteBalance_3_serialize(
    TDatabaseAutoWhiteBalance_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoWhiteBalance_3_reset(TDatabaseAutoWhiteBalance_3_t *pConfig);

#ifdef __cplusplus
}
#endif
