/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool lightWeightLevelEnable;
  float brightnessLevel[18];
  float weight[18];
} TDatabaseAutoWhiteBalance_4_LightWeightLevel_t;

typedef struct {
  bool preferenceGainEnable;
  float brightnessLevel[18];
  uint16_t grayRgain[18];
  uint16_t grayBgain[18];
} TDatabaseAutoWhiteBalance_4_PreferenceGain_t;

typedef struct {
  bool customPositionEnable;
  float rg;
  float bg;
  float threshold;
  float weight;
} TDatabaseAutoWhiteBalance_4_ConfoundPositionCustom_t;

typedef struct {
  bool enable;
  bool confoundPointCustomEn;
  bool confoundPointCwfCustomPosEn;
  bool confoundPointTl84CustomPosEn;
  bool confoundPointD65CustomPosEn;
  bool faceAwbEnable;

  float confidenceThr[10];

  uint16_t temPreferenceA;
  uint16_t temPreferenceCwf;
  uint16_t temPreferenceD65;
  bool temPreferenceTemptureEnable;

  float confoundPointCwfRg;
  float confoundPointCwfBg;
  float confoundPointCwfThr;

  float confoundPointTl84Rg;
  float confoundPointTl84Bg;
  float confoundPointTl84Thr;

  float confoundPointD65Rg;
  float confoundPointD65Bg;
  float confoundPointD65Thr;

  TDatabaseAutoWhiteBalance_4_LightWeightLevel_t lightWeightLevel[10];
  TDatabaseAutoWhiteBalance_4_PreferenceGain_t grayPreference[10];
  TDatabaseAutoWhiteBalance_4_ConfoundPositionCustom_t
      confoundPositionCustom[25];

  uint16_t performanceOptiMode;
  float awbEnterLockThr;
  float awbEnterUnlockThr;

  bool awbDampingCfgUseDamping;
  bool awbDampingCfgUseManualDampCoff;
  float awbDampingCfgManualDampCoff;

  uint8_t faceAwbRoiNum;
  float faceWeight;
  float faceAwbRg;
  float faceAwbBg;

  uint8_t roiNum;
  float roiWeight;
  float roiWindow[25][5];

  float awbTemWeight[7];
  uint16_t mode;

  DEPRECATED_MSG("use roiNum instead") uint8_t roiNumber;
  DEPRECATED_MSG("use useCCMatrix instead") bool useCcMatrix;
  DEPRECATED_MSG("use useCCOffset instead") bool useCcOffset;

  LEGACY TDatabaseState_t *pState;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED uint16_t grayPreferenceIdx;
  RESERVED uint16_t lightWeightLevelIdx;
  uint16_t confoundPositionCustomIdx;
} TDatabaseAutoWhiteBalance_4_t;

int TDatabaseAutoWhiteBalance_4_parse(TJsonValue_t *pValue,
                                      TDatabaseAutoWhiteBalance_4_t *pConfig);

int TDatabaseAutoWhiteBalance_4_serialize(
    TDatabaseAutoWhiteBalance_4_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoWhiteBalance_4_reset(TDatabaseAutoWhiteBalance_4_t *pConfig);

#ifdef __cplusplus
}
#endif
