/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain[20];
  uint8_t strength[20];
  uint8_t highStrength[20];
  uint8_t lowStrength[20];
  uint8_t globalStrength[20];
  int16_t contrast[20];
  uint8_t flatStrength[20];
  uint8_t flatThr[20];
  uint16_t entropySlope[20];
  uint16_t entropyBase[20];

  SIMULATOR bool hdr;
} TDatabaseAutoWideDynamicRange_4_1_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoWideDynamicRange_4_1_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableNumber;
  RESERVED size_t tableIdx;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoWideDynamicRange_4_1_t;

int TDatabaseAutoWideDynamicRange_4_1_parse(
    TJsonValue_t *pValue, TDatabaseAutoWideDynamicRange_4_1_t *pConfig);

int TDatabaseAutoWideDynamicRange_4_1_serialize(
    TDatabaseAutoWideDynamicRange_4_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoWideDynamicRange_4_1_reset(
    TDatabaseAutoWideDynamicRange_4_1_t *pConfig);

#ifdef __cplusplus
}
#endif
