/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain[20];
  uint8_t strengthCfgHighStrength[20];
  uint16_t strengthCfgLowStrength[20];
  uint16_t ltmWeightCfgEntropyBase[20];
  uint16_t ltmWeightCfgWdrLumaThr[20];
  uint16_t ltmWeightCfgEntropySlope[20];
  uint8_t ltmCfgFlatLevel[20];
  uint8_t gtmCfgFlatLevelGlobal[20];
  float satAdjustCfgSatRange[20];
  uint16_t satAdjustCfgSatThrGainDown[20];
  uint16_t satAdjustCfgSatThrGainUp[20];
  float degammaCfgdeGamma[20];
  float highLightCfgBaseLog[20];
  uint8_t haloColCfgLightSatLoThr[20];
  uint8_t haloColCfgLightSatHiThr[20];

  float haloColCfgLightRedThrLog[20][4];
  float haloColCfgLightGreenThrLog[20][4];
  float haloColCfgLightBlueThrLog[20][4];
  float haloColCfgLightYellowThrLog[20][4];
  float haloColCfgLightCyanThrLog[20][4];
  float haloColCfgLightMagentaThrLog[20][4];

  float edr[20];
  int16_t ltmWeightCfgContrast[20][20];
  uint16_t gtmWeightCfgFixedWeight[20][20];
  uint8_t gtmCfgLogWeight[20][20];
  float gtmCfgLogAnchorXLog[20][20];
  uint16_t gtmCfgLogAnchorSlope[20][20];
  uint16_t gainLimitCfgMaxGain[20][20];
  uint8_t highLightCfgSlope[20][20];
  bool lightEn[20][20];
  uint8_t colorWeiCfgWdrColorWeight[20][20][3];

  DEPRECATED_MSG("use 'gain' instead") float gains[20];
  DEPRECATED_MSG("use 'strengthCfgHighStrength' instead")
  uint8_t highStrength[20];
  DEPRECATED_MSG("use 'strengthCfgLowStrength' instead")
  uint16_t lowStrength[20];
  DEPRECATED_MSG("use 'ltmWeightCfgEntropyBase' instead")
  uint16_t entropyBase[20];
  DEPRECATED_MSG("use 'ltmWeightCfgWdrLumaThr' instead")
  uint16_t wdrLumaThr[20];
  DEPRECATED_MSG("use 'ltmWeightCfgEntropySlope' instead")
  uint16_t entropySlope[20];
  DEPRECATED_MSG("use 'ltmCfgFlatLevel' instead") uint8_t flatLevel[20];
  DEPRECATED_MSG("use 'gtmCfgFlatLevelGlobal' instead")
  uint8_t flatLevelGlobal[20];
  DEPRECATED_MSG("use 'satAdjustCfgSatRange' instead") float satRange[20];
  DEPRECATED_MSG("use 'satAdjustCfgSatThrGainDown' instead")
  uint16_t satThrGainDown[20];
  DEPRECATED_MSG("use 'satAdjustCfgSatThrGainUp' instead")
  uint16_t satThrGainUp[20];
  DEPRECATED_MSG("use 'degammaCfgdeGamma' instead") float deGamma[20];
  DEPRECATED_MSG("use 'highLightCfgBaseLog' instead") float hlcBaseLog[20];
  DEPRECATED_MSG("use 'haloColCfgLightSatLoThr' instead")
  uint8_t lightSatLoThr[20];
  DEPRECATED_MSG("use 'haloColCfgLightSatHiThr' instead")
  uint8_t lightSatHiThr[20];

  DEPRECATED_MSG("use 'haloColCfgLightRedThrLog' instead")
  float lightRedThrLog[20][4];
  DEPRECATED_MSG("use 'haloColCfgLightGreenThrLog' instead")
  float lightGreenThrLog[20][4];
  DEPRECATED_MSG("use 'haloColCfgLightBlueThrLog' instead")
  float lightBlueThrLog[20][4];
  DEPRECATED_MSG("use 'haloColCfgLightYellowThrLog' instead")
  float lightYellowThrLog[20][4];
  DEPRECATED_MSG("use 'haloColCfgLightCyanThrLog' instead")
  float lightCyanThrLog[20][4];
  DEPRECATED_MSG("use 'haloColCfgLightMagentaThrLog' instead")
  float lightMagentaThrLog[20][4];

  DEPRECATED_MSG("use 'ltmWeightCfgContrast' instead") int16_t contrast[20][20];
  DEPRECATED_MSG("use 'gtmWeightCfgFixedWeight' instead")
  uint16_t fixedWeight[20][20];
  DEPRECATED_MSG("use 'gtmCfgLogWeight' instead") uint8_t logWeight[20][20];
  DEPRECATED_MSG("use 'gtmCfgLogAnchorXLog' instead")
  float logAnchorXLog[20][20];
  DEPRECATED_MSG("use 'gtmCfgLogAnchorSlope' instead")
  uint16_t logAnchorSlope[20][20];
  DEPRECATED_MSG("use 'gainLimitCfgMaxGain' instead") uint16_t maxGain[20][20];
  DEPRECATED_MSG("use 'highLightCfgSlope' instead") uint8_t hlcSlope[20][20];

  DEPRECATED_MSG("use 'colorWeiCfgWdrColorWeight' instead")
  uint8_t wdrColorWeight[20][20][3];

  SIMULATOR bool hdr;
} TDatabaseAutoWideDynamicRange_5_2_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoWideDynamicRange_5_2_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoWideDynamicRange_5_2_t;

int TDatabaseAutoWideDynamicRange_5_2_parse(
    TJsonValue_t *pValue, TDatabaseAutoWideDynamicRange_5_2_t *pConfig);

int TDatabaseAutoWideDynamicRange_5_2_serialize(
    TDatabaseAutoWideDynamicRange_5_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoWideDynamicRange_5_2_reset(
    TDatabaseAutoWideDynamicRange_5_2_t *pConfig);

#ifdef __cplusplus
}
#endif
