/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain[20];
  uint8_t highStrength[20];
  uint16_t lowStrength[20];
  uint16_t entropyBase[20];
  uint16_t wdrLumaThr[20];
  uint16_t entropySlope[20];
  uint8_t flatLevel[20];
  uint8_t flatLevelGlobal[20];
  float satRange[20];
  uint16_t satThrGainDown[20];
  uint16_t satThrGainUp[20];
  float deGamma[20];
  float hlcBaseLog[20];
  uint8_t lightSatLoThr[20];
  uint8_t lightSatHiThr[20];

  float lightRedThrLog[20][4];
  float lightGreenThrLog[20][4];
  float lightBlueThrLog[20][4];
  float lightYellowThrLog[20][4];
  float lightCyanThrLog[20][4];
  float lightMagentaThrLog[20][4];

  int16_t contrast[20];
  uint16_t fixedWeight[20];
  uint8_t logWeight[20];
  float logAnchorXLog[20];
  uint16_t logAnchorSlope[20];
  uint16_t maxGain[20];
  uint8_t hlcSlope[20];
  bool lightEn[20];
  uint8_t wdrColorWeight[20][3];

  DEPRECATED_MSG("use 'gain' instead") float gains[20];
  SIMULATOR bool hdr;
} TDatabaseAutoWideDynamicRange_5_2_1_Table_t;

typedef struct {
  bool enable;

  TDatabaseAutoWideDynamicRange_5_2_1_Table_t tables[T_DATABASE_AUTO_TABLE_SUM];

  LEGACY TDatabaseState_t *pState;

  RESERVED size_t tableIdx;
  RESERVED size_t tableNumber;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseAutoWideDynamicRange_5_2_1_t;

int TDatabaseAutoWideDynamicRange_5_2_1_parse(
    TJsonValue_t *pValue, TDatabaseAutoWideDynamicRange_5_2_1_t *pConfig);

int TDatabaseAutoWideDynamicRange_5_2_1_serialize(
    TDatabaseAutoWideDynamicRange_5_2_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseAutoWideDynamicRange_5_2_1_reset(
    TDatabaseAutoWideDynamicRange_5_2_1_t *pConfig);

#ifdef __cplusplus
}
#endif
