/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float ccMatrix[9];
  float ccOffset[3];
  bool overrideCaliEn;

  LEGACY TDatabaseState_t state;

  DEPRECATED_MSG("use overrideCaliEn instead")
  bool isOverrideCalibration;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED size_t bufferNumber;
  TCommonBuffer_t *pBuffers;
} TDatabaseColorCorrectionMatrix_t;

int TDatabaseColorCorrectionMatrix_parse(
    TJsonValue_t *pValue, TDatabaseColorCorrectionMatrix_t *pConfig);

int TDatabaseColorCorrectionMatrix_parse2(
    TCommonBuffer_t *pBuffer, TDatabaseColorCorrectionMatrix_t *pConfig);

int TDatabaseColorCorrectionMatrix_serialize(
    TDatabaseColorCorrectionMatrix_t *pConfig, TJsonValue_t *pValue);

int TDatabaseColorCorrectionMatrix_reset(
    TDatabaseColorCorrectionMatrix_t *pConfig);

#ifdef __cplusplus
}
#endif
