/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  bool cnrEnable;
  float cnrSigmaLayer[4];
  uint8_t cnrStrength1;
  uint8_t cnrStrength2;
  uint8_t cnrTextureMaskSelect;

  bool ynrEnable;
  float ynrSigma;
  uint8_t ynrStrength;
  uint8_t ynrStrength2;

  LEGACY TDatabaseState_t state;

  DEPRECATED_MSG("use enable instead") bool isEnable;
  DEPRECATED_MSG("use cnrSigmaLayer instead") float cSigmaLayer[4];
  DEPRECATED_MSG("use cnrStrength1 instead") uint8_t cnrStrength;
  // DEPRECATED_MSG("use strength2 instead") uint8_t cnrStrength2;
  DEPRECATED_MSG("use cnrTextureMaskSelect instead")
  uint8_t textureMaskSelect;
  DEPRECATED_MSG("use sigma instead") float ySigma;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseColorNoiseReduction_2_1_t;

int TDatabaseColorNoiseReduction_2_1_parse(
    TJsonValue_t *pValue, TDatabaseColorNoiseReduction_2_1_t *pConfig);

int TDatabaseColorNoiseReduction_2_1_serialize(
    TDatabaseColorNoiseReduction_2_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseColorNoiseReduction_2_1_reset(
    TDatabaseColorNoiseReduction_2_1_t *pConfig);

#ifdef __cplusplus
}
#endif
