/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float sigmaLayer[3];
  uint8_t strength1;
  uint8_t textureMaskSelect;

  DEPRECATED_MSG("use sigmaLayer instead") float cSigmaLayer[3];
  DEPRECATED_MSG("use strength1 instead") uint8_t cnrStrength;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseColorNoiseReduction_2_2_t;

int TDatabaseColorNoiseReduction_2_2_parse(
    TJsonValue_t *pValue, TDatabaseColorNoiseReduction_2_2_t *pConfig);

int TDatabaseColorNoiseReduction_2_2_serialize(
    TDatabaseColorNoiseReduction_2_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseColorNoiseReduction_2_2_reset(
    TDatabaseColorNoiseReduction_2_2_t *pConfig);

#ifdef __cplusplus
}
#endif
