/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float contrast;
  float bright;
  float saturation;
  float hue;

  uint32_t yuvRange;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseColorProcess_1_2_t;

int TDatabaseColorProcess_1_2_parse(TJsonValue_t *pValue,
                                    TDatabaseColorProcess_1_2_t *pConfig);

int TDatabaseColorProcess_1_2_serialize(TDatabaseColorProcess_1_2_t *pConfig,
                                        TJsonValue_t *pValue);

int TDatabaseColorProcess_1_2_reset(TDatabaseColorProcess_1_2_t *pConfig);

#ifdef __cplusplus
}
#endif
