/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool bptEnable;

  uint16_t bptNum;
  uint8_t bptOutMode;
  uint16_t bptPosX[2048];
  uint16_t bptPosY[2048];
  uint8_t lineMadFac[2][3];
  uint8_t lineThresh[2][3];
  uint16_t methodsSet[3];
  uint8_t outMode;
  uint8_t pgFac[2][3];
  uint8_t rgFac[2][3];
  uint8_t rndOffs[2][3];
  uint8_t rndThresh[2][3];
  uint8_t roLimits[2][3];
  uint8_t setUse;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseDefectPixelClusterCorrection_t;

int TDatabaseDefectPixelClusterCorrection_parse(
    TJsonValue_t *pValue, TDatabaseDefectPixelClusterCorrection_t *pConfig);

int TDatabaseDefectPixelClusterCorrection_serialize(
    TDatabaseDefectPixelClusterCorrection_t *pConfig, TJsonValue_t *pValue);

int TDatabaseDefectPixelClusterCorrection_reset(
    TDatabaseDefectPixelClusterCorrection_t *pConfig);

#ifdef __cplusplus
}
#endif
