/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Li, Renji since 2024 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint8_t denoiseLevel;
  uint8_t sharpenLevel;
  uint16_t chrHMode;
  uint16_t chrVMode;

  float aBlue;
  float aRed;
  float bBlue;
  float bRed;
  float cBlue;
  float cRed;
  int16_t centerHoffs;
  int16_t centerVoffs;

  bool cacEnable;
  bool fltEnable;
  bool overrideCaliEn;
  uint8_t threshold;

  DEPRECATED_MSG("use centerHoffs instead") int16_t centerHOffs;
  DEPRECATED_MSG("use centerVoffs instead") int16_t centerVOffs;
  DEPRECATED_MSG("use overrideCaliEn instead")
  bool isOverrideCalibration;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseDeMosaic_1_1_t;

int TDatabaseDeMosaic_1_1_parse(TJsonValue_t *pValue,
                                TDatabaseDeMosaic_1_1_t *pConfig);

int TDatabaseDeMosaic_1_1_serialize(TDatabaseDeMosaic_1_1_t *pConfig,
                                    TJsonValue_t *pValue);

int TDatabaseDeMosaic_1_1_reset(TDatabaseDeMosaic_1_1_t *pConfig);

#ifdef __cplusplus
}
#endif
