/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool dmscDeMoireEnable;
  bool dmscSharpenEnable;
  bool dmscSharpenLineEnable;
  bool dmscSkinEnable;
  bool dmscDePurpleEnable;
  bool dmscCacEnable;

  uint8_t demosaicThr;
  uint16_t dmscDirThrMax;
  uint16_t dmscDirThrMin;

  uint8_t dmscDemoireT1;
  uint8_t dmscDemoireT2Shift;
  uint16_t dmscDemoireR1;
  uint16_t dmscDemoireR2;
  uint16_t demoireEdgeR1;
  uint16_t demoireEdgeR2;
  uint16_t demoireEdgeT1;
  uint8_t demoireEdgeT2Shift;
  uint8_t dmscDemoireAreaThr;
  uint8_t dmscDemoireSatShrink;

  uint16_t dmscSharpenClipBlack;
  uint16_t dmscSharpenClipWhite;
  uint16_t dmscSharpenFactorBlack;
  uint16_t dmscSharpenFactorWhite;
  uint16_t dmscSharpenR1;
  uint16_t dmscSharpenR2;
  uint16_t dmscSharpenR3;
  uint16_t dmscSharpenT1;
  uint16_t dmscSharpenT3;
  uint8_t dmscSharpenSize;
  uint8_t dmscSharpenT2Shift;
  uint8_t dmscSharpenT4Shift;
  uint8_t dmscDenoiseStrength;

  uint16_t dmscSharpenLineR1;
  uint16_t dmscSharpenLineR2;
  uint16_t dmscSharpenLineStrength;
  uint16_t dmscSharpenLineThr;
  uint8_t dmscSharpenLineThrShift1;

  int16_t dmscSkinCbThrMax;
  int16_t dmscSkinCbThrMin;
  int16_t dmscSkinCrThrMax;
  int16_t dmscSkinCrThrMin;
  uint16_t dmscSkinYThrMax;
  uint16_t dmscSkinYThrMin;

  uint8_t dmscDepurpleCbcrMode;
  uint8_t dmscDepurpleSatShrink;
  uint8_t dmscDepurpleThr;

  float cacCfgABlue;
  float cacCfgARed;
  float cacCfgBBlue;
  float cacCfgBRed;
  float cacCfgCBlue;
  float cacCfgCRed;
  int16_t cacCfgCenterHoffs;
  int16_t cacCfgCenterVoffs;

  bool overrideCaliEn;

  // temp save config value when get current value
  RESERVED bool dmscDepurpleEnableTemp;
  RESERVED bool dmscSharpenEnableTemp;

  DEPRECATED_MSG("use centerHoffs instead") int16_t centerHOffs;
  DEPRECATED_MSG("use centerVoffs instead") int16_t centerVOffs;
  DEPRECATED_MSG("use demoireEdgeR1 instead") uint16_t deMoireEdgeR1;
  DEPRECATED_MSG("use demoireEdgeR2 instead") uint16_t deMoireEdgeR2;
  DEPRECATED_MSG("use demoireEdgeT1 instead") uint16_t deMoireEdgeT1;
  DEPRECATED_MSG("use demoireEdgeT2Shift instead") uint8_t deMoireEdgeT2Shift;
  DEPRECATED_MSG("use dmscDemoireAreaThr instead") uint8_t deMoireAreaThr;
  DEPRECATED_MSG("use dmscDemoireR1 instead") uint16_t deMoireR1;
  DEPRECATED_MSG("use dmscDemoireR2 instead") uint16_t deMoireR2;
  DEPRECATED_MSG("use dmscDemoireSatShrink instead") uint8_t deMoireSatShrink;
  DEPRECATED_MSG("use dmscDemoireT1 instead") uint8_t deMoireT1;
  DEPRECATED_MSG("use dmscDemoireT2Shift instead") uint8_t deMoireT2Shift;
  DEPRECATED_MSG("use demosaicThr instead") uint8_t deMosaicThr;
  DEPRECATED_MSG("use dmscDenoiseStrength instead") uint8_t deNoiseStrength;
  DEPRECATED_MSG("use dmscDepurpleCbcrMode instead") uint8_t dePurpleCbCrMode;
  DEPRECATED_MSG("use dmscDepurpleSatShrink instead") uint8_t dePurpleSatShrink;
  DEPRECATED_MSG("use dmscDepurpleThr instead") uint8_t dePurpleThr;
  DEPRECATED_MSG("use dmscDirThrMax instead") uint16_t dirThrMax;
  DEPRECATED_MSG("use dmscDirThrMin instead") uint16_t dirThrMin;
  DEPRECATED_MSG("use dmscSharpenClipBlack instead") uint16_t sharpenClipBlack;
  DEPRECATED_MSG("use dmscSharpenClipWhite instead") uint16_t sharpenClipWhite;
  DEPRECATED_MSG("use dmscSharpenFactorBlack instead")
  uint16_t sharpenFactorBlack;
  DEPRECATED_MSG("use dmscSharpenFactorWhite instead")
  uint16_t sharpenFactorWhite;
  DEPRECATED_MSG("use dmscSharpenLineR1 instead") uint16_t sharpenLineR1;
  DEPRECATED_MSG("use dmscSharpenLineR2 instead") uint16_t sharpenLineR2;
  DEPRECATED_MSG("use dmscSharpenLineStrength instead")
  uint16_t sharpenLineStrength;
  DEPRECATED_MSG("use dmscSharpenLineThr instead") uint16_t sharpenLineThr;
  DEPRECATED_MSG("use dmscSharpenLineThrShift1 instead")
  uint8_t sharpenLineThrShift1;
  DEPRECATED_MSG("use dmscSharpenR1 instead") uint16_t sharpenR1;
  DEPRECATED_MSG("use dmscSharpenR2 instead") uint16_t sharpenR2;
  DEPRECATED_MSG("use dmscSharpenR3 instead") uint16_t sharpenR3;
  DEPRECATED_MSG("use dmscSharpenSize instead") uint8_t sharpenSize;
  DEPRECATED_MSG("use dmscSharpenT1 instead") uint16_t sharpenT1;
  DEPRECATED_MSG("use dmscSharpenT2Shift instead") uint8_t sharpenT2Shift;
  DEPRECATED_MSG("use dmscSharpenT3 instead") uint16_t sharpenT3;
  DEPRECATED_MSG("use dmscSharpenT4Shift instead") uint8_t sharpenT4Shift;
  DEPRECATED_MSG("use dmscSkinCbThrMax instead") int16_t skinCbThrMax;
  DEPRECATED_MSG("use dmscSkinCbThrMin instead") int16_t skinCbThrMin;
  DEPRECATED_MSG("use dmscSkinCrThrMax instead") int16_t skinCrThrMax;
  DEPRECATED_MSG("use dmscSkinCrThrMin instead") int16_t skinCrThrMin;
  DEPRECATED_MSG("use dmscSkinYThrMax instead") uint16_t skinYThrMax;
  DEPRECATED_MSG("use dmscSkinYThrMin instead") uint16_t skinYThrMin;
  DEPRECATED_MSG("use overrideCaliEn instead")
  bool isOverrideCalibration;
  DEPRECATED_MSG("use cacCfgABlue instead") float aBlue;
  DEPRECATED_MSG("use cacCfgARed instead") float aRed;
  DEPRECATED_MSG("use cacCfgBBlue instead") float bBlue;
  DEPRECATED_MSG("use cacCfgBRed instead") float bRed;
  DEPRECATED_MSG("use cacCfgCBlue instead") float cBlue;
  DEPRECATED_MSG("use cacCfgCRed instead") float cRed;
  DEPRECATED_MSG("use cacCfgCenterHoffs instead") int16_t centerHoffs;
  DEPRECATED_MSG("use cacCfgCenterVoffs instead") int16_t centerVoffs;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseDeMosaic_2_t;

int TDatabaseDeMosaic_2_parse(TJsonValue_t *pValue,
                              TDatabaseDeMosaic_2_t *pConfig);

int TDatabaseDeMosaic_2_serialize(TDatabaseDeMosaic_2_t *pConfig,
                                  TJsonValue_t *pValue);

int TDatabaseDeMosaic_2_reset(TDatabaseDeMosaic_2_t *pConfig);

#ifdef __cplusplus
}
#endif
