/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float div;
  float gradient;
  float min;
  float noiseCurve[17];
  float offset;
  float sigmaG;
  float sigmaRb;

  float gain;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseDeNoisePreFilter_t;

int TDatabaseDeNoisePreFilter_parse(TJsonValue_t *pValue,
                                    TDatabaseDeNoisePreFilter_t *pConfig);

int TDatabaseDeNoisePreFilter_serialize(TDatabaseDeNoisePreFilter_t *pConfig,
                                        TJsonValue_t *pValue);

int TDatabaseDeNoisePreFilter_reset(TDatabaseDeNoisePreFilter_t *pConfig);

#ifdef __cplusplus
}
#endif
