/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float digitalGainB;
  float digitalGainGb;
  float digitalGainGr;
  float digitalGainR;

  DEPRECATED_MSG("use digitalGainB instead") float b;
  DEPRECATED_MSG("use digitalGainGb instead") float gb;
  DEPRECATED_MSG("use digitalGainGr instead") float gr;
  DEPRECATED_MSG("use digitalGainR instead") float r;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseDigitalGain_t;

int TDatabaseDigitalGain_parse(TJsonValue_t *pValue,
                               TDatabaseDigitalGain_t *pConfig);

int TDatabaseDigitalGain_serialize(TDatabaseDigitalGain_t *pConfig,
                                   TJsonValue_t *pValue);

int TDatabaseDigitalGain_reset(TDatabaseDigitalGain_t *pConfig);

#ifdef __cplusplus
}
#endif
