/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  TDatabaseState_t state;

  float gaussAmpNeg;
  float gaussAmpPos;
  float gaussMeanNeg;
  float gaussMeanPos;
  float gaussSigmaNeg;
  float gaussSigmaPos;

  // simulator section
  char class_[T_DATABASE_CLASS_NAME_LENGTH];
  bool enable;
} TDatabaseDynamicContrastImprovementHistogram_t;

int TDatabaseDynamicContrastImprovementHistogram_parse(
    TJsonValue_t *pValue,
    TDatabaseDynamicContrastImprovementHistogram_t *pConfig);

int TDatabaseDynamicContrastImprovementHistogram_serialize(
    TDatabaseDynamicContrastImprovementHistogram_t *pConfig,
    TJsonValue_t *pValue);

int TDatabaseDynamicContrastImprovementHistogram_reset(
    TDatabaseDynamicContrastImprovementHistogram_t *pConfig);

#ifdef __cplusplus
}
#endif
