/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Li, Renji since 2024 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  uint32_t eeEdgeGain;
  uint8_t eeSrcStrength;
  uint8_t eeStrength;
  uint16_t eeUvGain;
  uint32_t eeYDownGain;
  uint32_t eeYUpGain;

  LEGACY TDatabaseState_t state;

  DEPRECATED_MSG("use eeEdgeGain instead") uint32_t edgeGain;
  DEPRECATED_MSG("use eeSrcStrength instead") uint8_t srcStrength;
  DEPRECATED_MSG("use eeStrength instead") uint8_t strength;
  DEPRECATED_MSG("use eeUvGain instead") uint16_t uvGain;
  DEPRECATED_MSG("use eeYDownGain instead") uint32_t yDownGain;
  DEPRECATED_MSG("use eeYUpGain instead") uint32_t yUpGain;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseEdgeEnhance_t;

int TDatabaseEdgeEnhance_parse(TJsonValue_t *pValue,
                               TDatabaseEdgeEnhance_t *pConfig);

int TDatabaseEdgeEnhance_serialize(TDatabaseEdgeEnhance_t *pConfig,
                                   TJsonValue_t *pValue);

int TDatabaseEdgeEnhance_reset(TDatabaseEdgeEnhance_t *pConfig);

#ifdef __cplusplus
}
#endif
