/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool caEnable;
  bool curveEnable;
  bool dciEnable;

  uint32_t eeEdgeGain;
  uint8_t eeSrcStrength;
  uint8_t eeStrength;
  uint16_t eeUvGain;
  uint32_t eeYDownGain;
  uint32_t eeYUpGain;

  uint16_t caMode;
  uint16_t caCurve[65];

  uint16_t dciCurve[65];

  float dciCurveCfgDegamma;
  uint16_t dciCurveCfgDciMode;
  float dciCurveCfgLowlumaIdx;
  float dciCurveCfgMiddlelumaIdx;
  float dciCurveCfgHighlumaIdx;
  uint16_t dciCurveCfgInflctStartY;
  uint16_t dciCurveCfgInflct1X;
  uint16_t dciCurveCfgInflct1Y;
  uint16_t dciCurveCfgInflct2X;
  uint16_t dciCurveCfgInflct2Y;
  uint16_t dciCurveCfgInflctStopY;

  // temp save config value when get current value
  RESERVED bool caEnTemp;
  RESERVED bool dciEnTemp;

  LEGACY TDatabaseState_t state;

  DEPRECATED_MSG("use eeEdgeGain instead") uint32_t edgeGain;
  DEPRECATED_MSG("use eeSrcStrength instead") uint8_t srcStrength;
  DEPRECATED_MSG("use eeStrength instead") uint8_t strength;
  DEPRECATED_MSG("use eeUvGain instead") uint16_t uvGain;
  DEPRECATED_MSG("use eeYDownGain instead") uint32_t yDownGain;
  DEPRECATED_MSG("use eeYUpGain instead") uint32_t yUpGain;
  DEPRECATED_MSG("use dciCurveCfgDegamma instead") float degamma;
  DEPRECATED_MSG("use dciCurveCfgDciMode instead") uint16_t dciMode;
  DEPRECATED_MSG("use dciCurveCfgLowlumaIdx instead") float lowlumaIdx;
  DEPRECATED_MSG("use dciCurveCfgMiddlelumaIdx instead")
  float middlelumaIdx;
  DEPRECATED_MSG("use dciCurveCfgHighlumaIdx instead") float highlumaIdx;
  DEPRECATED_MSG("use dciCurveCfgInflctStartY instead") uint16_t inflctStartY;
  DEPRECATED_MSG("use dciCurveCfgInflct1X instead") uint16_t inflct1X;
  DEPRECATED_MSG("use dciCurveCfgInflct1Y instead") uint16_t inflct1Y;
  DEPRECATED_MSG("use dciCurveCfgInflct2X instead") uint16_t inflct2X;
  DEPRECATED_MSG("use dciCurveCfgInflct2Y instead") uint16_t inflct2Y;
  DEPRECATED_MSG("use dciCurveCfgInflctStopY instead") uint16_t inflctStopY;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseEdgeEnhance_2_t;

int TDatabaseEdgeEnhance_2_parse(TJsonValue_t *pValue,
                                 TDatabaseEdgeEnhance_2_t *pConfig);

int TDatabaseEdgeEnhance_2_serialize(TDatabaseEdgeEnhance_2_t *pConfig,
                                     TJsonValue_t *pValue);

int TDatabaseEdgeEnhance_2_reset(TDatabaseEdgeEnhance_2_t *pConfig);

#ifdef __cplusplus
}
#endif
