/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool caEnable;
  bool curveEnable;
  bool dciEnable;
  bool depurpleEn;
  bool sharpLimitEnable;
  bool yuvDomainEnable;
  uint8_t skinProcEn;

  uint16_t eeSrcStrength;
  uint16_t eeSrcStrengthSkin;

  uint8_t edgeNrLvl;
  uint8_t edgeScale;
  bool edgeUseAuxiDir;
  uint8_t detailLvl;
  uint8_t detailScaler;
  uint16_t detailPreEnhanceStr;

  uint8_t skinDetectStr;
  uint16_t skinThrYMin;
  uint16_t skinThrYMax;
  int16_t skinThrCrMin;
  int16_t skinThrCrMax;
  int16_t skinThrCbMin;
  int16_t skinThrCbMax;

  uint16_t hfMergeCurve[4];
  uint16_t hfMergeCurveSkin[4];

  uint16_t gradTh[2];
  uint16_t gradThSkin[2];

  uint8_t eeStrength;
  uint8_t sharpCurveLvl;
  uint8_t sharpskinCurveLvl;
  uint16_t sharpGain[2];
  uint16_t sharpGainSkin[2];
  uint8_t sharpGainUv;
  uint8_t sharpLimitType;
  uint16_t sharpLimt[2];
  uint16_t sharpLimitSkin[2];

  uint8_t depfDetectRange;
  uint16_t depfLimit[4];
  uint16_t depfDetectLumaTh;
  uint16_t depfDetectLumaDiff;
  uint16_t depfCompLumaDiff;
  uint16_t depfSatStr;
  uint16_t depfFixStr;

  uint16_t lutChromaTbl[65];
  uint16_t caMode;

  float degamma;
  uint16_t dciCurve[65];

  uint16_t dciMode;
  float lowlumaIdx;
  float middlelumaIdx;
  float highlumaIdx;
  uint16_t inflctStartY;
  uint16_t inflct1X;
  uint16_t inflct1Y;
  uint16_t inflct2X;
  uint16_t inflct2Y;
  uint16_t inflctStopY;

  // temp save config value when get current value
  RESERVED bool eeCaEnTemp;
  RESERVED bool eeDciEnTemp;
  RESERVED bool eeDepurpleEnTemp;
  RESERVED bool eeProcEnTemp;

  DEPRECATED_MSG("use lutChromaTbl instead") uint16_t caCurve[65];
  DEPRECATED_MSG("use skinThrCbMin instead") int16_t cbDownThr;
  DEPRECATED_MSG("use skinThrCbMax instead") int16_t cbUpThr;
  DEPRECATED_MSG("use skinThrCrMin instead") int16_t crDownThr;
  DEPRECATED_MSG("use skinThrCrMax instead") int16_t crUpThr;
  // DEPRECATED_MSG("use lutLumaTbl instead") uint16_t dciCurve[65];
  DEPRECATED_MSG("use degamma instead") float deGamma;
  DEPRECATED_MSG("use depfFixStr instead") uint16_t depfFixStrength;
  DEPRECATED_MSG("use depfSatStr instead") uint16_t depfSatStrength;
  DEPRECATED_MSG("use detailLvl instead") uint8_t detailLevel;
  DEPRECATED_MSG("use detailPreEnhanceStr instead")
  uint16_t detailPreEnhanceStrength;
  DEPRECATED_MSG("use edgeNrLvl instead") uint8_t edgeNrLevel;
  DEPRECATED_MSG("use edgeScale instead") uint8_t edgeScaler;
  DEPRECATED_MSG("use sharpCurveLvl instead") uint8_t sharpCurveLevel;
  DEPRECATED_MSG("use sharpLimt instead") uint16_t sharpLimit[2];
  DEPRECATED_MSG("use sharpskinCurveLvl instead") uint8_t sharpSkinCurveLevel;
  DEPRECATED_MSG("use skinDetectStr instead") uint16_t skinDetectStrength;
  DEPRECATED_MSG("use eeSrcStrength instead") uint16_t sourceStrength;
  DEPRECATED_MSG("use eeSrcStrengthSkin instead") uint16_t sourceStrengthSkin;
  DEPRECATED_MSG("use skinThrYMin instead") uint16_t yDownThr;
  DEPRECATED_MSG("use skinThrYMax instead") uint16_t yUpThr;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseEdgeEnhance_3_t;

int TDatabaseEdgeEnhance_3_parse(TJsonValue_t *pValue,
                                 TDatabaseEdgeEnhance_3_t *pConfig);

int TDatabaseEdgeEnhance_3_serialize(TDatabaseEdgeEnhance_3_t *pConfig,
                                     TJsonValue_t *pValue);

int TDatabaseEdgeEnhance_3_reset(TDatabaseEdgeEnhance_3_t *pConfig);

#ifdef __cplusplus
}
#endif
