/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

#define T_DATABASE_EXPOSURE_CONTROL_2_NUMBER_MAX 4

typedef struct {
  float analog[T_DATABASE_EXPOSURE_CONTROL_2_NUMBER_MAX];
  float digital[T_DATABASE_EXPOSURE_CONTROL_2_NUMBER_MAX];
} TDatabaseExposureControl_2_Gain_t;

typedef struct {
  // bool enable;

  TDatabaseExposureControl_2_Gain_t gain;
  float integrationTime[T_DATABASE_EXPOSURE_CONTROL_2_NUMBER_MAX];
  float totalGain;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseExposureControl_2_t;

int TDatabaseExposureControl_2_parse(TJsonValue_t *pValue,
                                     TDatabaseExposureControl_2_t *pConfig);

int TDatabaseExposureControl_2_serialize(TDatabaseExposureControl_2_t *pConfig,
                                         TJsonValue_t *pValue);

int TDatabaseExposureControl_2_reset(TDatabaseExposureControl_2_t *pConfig);

#ifdef __cplusplus
}
#endif
