/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint16_t mode;
  uint32_t position;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseFocusControl_t;

int TDatabaseFocusControl_parse(TJsonValue_t *pValue,
                                TDatabaseFocusControl_t *pConfig);

int TDatabaseFocusControl_serialize(TDatabaseFocusControl_t *pConfig,
                                    TJsonValue_t *pValue);

int TDatabaseFocusControl_reset(TDatabaseFocusControl_t *pConfig);

#ifdef __cplusplus
}
#endif
