/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Cao, Zheng since 2024 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

#define T_DATABASE_GAMMA_POINTS_MAX 64

typedef struct {
  bool enable;

  bool standard;
  float standardVal;
  uint16_t curve[17];
  uint16_t curveMode;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseGammaCorrection_t;

int TDatabaseGammaCorrection_parse(TJsonValue_t *pValue,
                                   TDatabaseGammaCorrection_t *pConfig);

int TDatabaseGammaCorrection_serialize(TDatabaseGammaCorrection_t *pConfig,
                                       TJsonValue_t *pValue);

int TDatabaseGammaCorrection_reset(TDatabaseGammaCorrection_t *pConfig);

#ifdef __cplusplus
}
#endif
