/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

#define T_DATABASE_GAMMA_POINTS_MAX 64

typedef struct {
  bool enable;

  bool standard;
  float standardVal;
  uint16_t curve[64];
  bool userCurveX;
  uint32_t curvePx[64];

  DEPRECATED_MSG("use standard instead") bool isStandard;
  DEPRECATED_MSG("use userCurveX instead") bool isUserCurveX;

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseGammaCorrection_2_t;

int TDatabaseGammaCorrection_2_parse(TJsonValue_t *pValue,
                                     TDatabaseGammaCorrection_2_t *pConfig);

int TDatabaseGammaCorrection_2_serialize(TDatabaseGammaCorrection_2_t *pConfig,
                                         TJsonValue_t *pValue);

int TDatabaseGammaCorrection_2_reset(TDatabaseGammaCorrection_2_t *pConfig);

#ifdef __cplusplus
}
#endif
