/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool bwCorEnable;

  uint8_t colorWeiCfgGtmRgbCoef[3];
  uint8_t colorWeiCfgGtmLightnessWeight;
  uint8_t colorWeiCfgGtmColorWeight[3];

  uint16_t blackWhiteCorCfgMode;
  double blackWhiteCorCfgMinLog;
  double blackWhiteCorCfgMaxLog;
  double blackWhiteCorCfgDampCoef;

  uint16_t curveCfgGtmCurveSelect;
  uint16_t curveCfgShiftBit;
  double curveCfgPwlKneeXLog;
  double curveCfgPwlKneeYLog;
  double curveCfgPwlMaxLog;
  double curveCfgPwlMinLog;
  float curveCfgLogKneeXLog;
  float curveCfgLogKneeSlope;
  uint32_t curveCfgUserCurve[129];

  DEPRECATED_MSG("use 'colorWeiCfgGtmRgbCoef' instead") uint8_t rgbCoef[3];
  DEPRECATED_MSG("use 'colorWeiCfgGtmLightnessWeight' instead")
  uint8_t lightnessWeight;
  DEPRECATED_MSG("use 'colorWeiCfgGtmColorWeight' instead")
  uint8_t colorWeight[3];

  DEPRECATED_MSG("use 'blackWhiteCorCfgMode' instead")
  uint16_t bwCorMode;
  DEPRECATED_MSG("use 'blackWhiteCorCfgMinLog' instead")
  double bwCorMinLog;
  DEPRECATED_MSG("use 'blackWhiteCorCfgMaxLog' instead")
  double bwCorMaxLog;
  DEPRECATED_MSG("use 'blackWhiteCorCfgDampCoef' instead")
  double bwCorDampCoef;

  DEPRECATED_MSG("use 'curveCfgGtmCurveSelect' instead")
  uint16_t curveSelect;
  DEPRECATED_MSG("use 'curveCfgShiftBit' instead")
  uint16_t shiftBit;
  DEPRECATED_MSG("use 'curveCfgPwlKneeXLog' instead")
  double pwlKneeXLog;
  DEPRECATED_MSG("use 'curveCfgPwlKneeYLog' instead")
  double pwlKneeYLog;
  DEPRECATED_MSG("use 'curveCfgPwlMaxLog' instead")
  double pwlMaxLog;
  DEPRECATED_MSG("use 'curveCfgPwlMinLog' instead")
  double pwlMinLog;
  DEPRECATED_MSG("use 'curveCfgLogKneeXLog' instead")
  float logKneeXLog;
  DEPRECATED_MSG("use 'curveCfgLogKneeSlope' instead")
  float logKneeSlope;
  DEPRECATED_MSG("use 'curveCfgUserCurve' instead")
  uint32_t userCurve[129];

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseGlobalToneMapping_t;

int TDatabaseGlobalToneMapping_parse(TJsonValue_t *pValue,
                                     TDatabaseGlobalToneMapping_t *pConfig);

int TDatabaseGlobalToneMapping_serialize(TDatabaseGlobalToneMapping_t *pConfig,
                                         TJsonValue_t *pValue);

int TDatabaseGlobalToneMapping_reset(TDatabaseGlobalToneMapping_t *pConfig);

#ifdef __cplusplus
}
#endif
