/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Cao, Zheng since 2024 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint8_t mode;
  uint16_t rgbOffset;
  uint16_t lumOffset;
  float gamma;
  uint16_t curve[33];

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseGlobalWideDynamicRange_t;

int TDatabaseGlobalWideDynamicRange_parse(
    TJsonValue_t *pValue, TDatabaseGlobalWideDynamicRange_t *pConfig);

int TDatabaseGlobalWideDynamicRange_serialize(
    TDatabaseGlobalWideDynamicRange_t *pConfig, TJsonValue_t *pValue);

int TDatabaseGlobalWideDynamicRange_reset(
    TDatabaseGlobalWideDynamicRange_t *pConfig);

#ifdef __cplusplus
}
#endif
