/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Li, Renji since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain;
  float gradient;
  float offset;
  float min;
  float div;
  float sigmaG;
  float sigmaRb;
  float noiseCurve[17];

  bool enable;
} TDatabaseHighDynamicRange_2_Dpf_t;

typedef struct {
  bool enable;

  float ratio[2];
  float transRange[4][2];
  uint8_t colorWeight[3];
  int8_t extendBit[2];

  uint16_t motionWeight[2];
  uint16_t motionLowerThrLs;
  uint16_t motionUpperThrLs;
  uint16_t motionLowerThrLsvs;
  uint16_t motionUpperThrLsvs;
  uint16_t darkLowerThrLs;
  uint16_t darkUpperThrLs;
  uint16_t darkLowerThrLsvs;
  uint16_t darkUpperThrLsvs;

  TDatabaseHighDynamicRange_2_Dpf_t dpf[3];

  uint16_t baseFrame;
  bool bypass;
  uint16_t bypassSelect;
  bool dGainEnable;
  float dGain[3][4];
  bool motionEnable[2];
  uint16_t stitchingMode;
  uint16_t sensorType;

  DEPRECATED_MSG("use darkLowerThrLsvs instead")
  uint16_t darkLowerThrLsVs;
  DEPRECATED_MSG("use darkUpperThrLsvs instead")
  uint16_t darkUpperThrLsVs;
  DEPRECATED_MSG("use motionLowerThrLsvs instead")
  uint16_t motionLowerThrLsVs;
  DEPRECATED_MSG("use motionUpperThrLsvs instead")
  uint16_t motionUpperThrLsVs;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED size_t dpfIdx;
  RESERVED bool isAlreadyEnabled;
} TDatabaseHighDynamicRange_2_t;

int TDatabaseHighDynamicRange_2_parse(TJsonValue_t *pValue,
                                      TDatabaseHighDynamicRange_2_t *pConfig);

int TDatabaseHighDynamicRange_2_serialize(
    TDatabaseHighDynamicRange_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseHighDynamicRange_2_reset(TDatabaseHighDynamicRange_2_t *pConfig);

#ifdef __cplusplus
}
#endif
