/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float ratio[2];
  float transRange[4][2];
  uint8_t colorWeight[3];
  int8_t extendBit[2];

  bool bypass;
  uint16_t bypassSelect;
  uint16_t sensorType;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED bool isAlreadyEnabled;
} TDatabaseHighDynamicRange_2_1_t;

int TDatabaseHighDynamicRange_2_1_parse(
    TJsonValue_t *pValue, TDatabaseHighDynamicRange_2_1_t *pConfig);

int TDatabaseHighDynamicRange_2_1_serialize(
    TDatabaseHighDynamicRange_2_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseHighDynamicRange_2_1_reset(
    TDatabaseHighDynamicRange_2_1_t *pConfig);

#ifdef __cplusplus
}
#endif
