/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  float gain;
  float gradient;
  float offset;
  float min;
  float div;
  float sigmaG;
  float sigmaRb;
  float noiseCurve[17];

  bool enableDpf;
} TDatabaseHighDynamicRange_3_Dpf_t;

typedef struct {
  bool enable;

  float ratio[2];
  float transRange[4][2];
  uint8_t colorWeight[3];
  int8_t extendBit[2];

  uint16_t deghostCfgMotionWeight[2];
  uint16_t deghostCfgMotionLowerThrLs;
  uint16_t deghostCfgMotionUpperThrLs;
  uint16_t deghostCfgMotionLowerThrLsvs;
  uint16_t deghostCfgMotionUpperThrLsvs;
  uint16_t deghostCfgDarkLowerThrLs;
  uint16_t deghostCfgDarkUpperThrLs;
  uint16_t deghostCfgDarkLowerThrLsvs;
  uint16_t deghostCfgDarkUpperThrLsvs;

  TDatabaseHighDynamicRange_3_Dpf_t dpf[3];

  bool bypass;
  uint16_t bypassSelect;
  uint16_t sensorType;
  bool motionEnable[2];

  DEPRECATED_MSG("use deghostCfgDarkLowerThrLsvs instead")
  uint16_t darkLowerThrLsVs;
  DEPRECATED_MSG("use deghostCfgDarkUpperThrLsvs instead")
  uint16_t darkUpperThrLsVs;
  DEPRECATED_MSG("use deghostCfgMotionLowerThrLsvs instead")
  uint16_t motionLowerThrLsVs;
  DEPRECATED_MSG("use deghostCfgMotionUpperThrLsvs instead")
  uint16_t motionUpperThrLsVs;

  LEGACY TDatabaseState_t state;

  // shell
  bool isStatistics;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED size_t dpfIdx;
  RESERVED bool isAlreadyEnabled;
} TDatabaseHighDynamicRange_3_t;

int TDatabaseHighDynamicRange_3_parse(TJsonValue_t *pValue,
                                      TDatabaseHighDynamicRange_3_t *pConfig);

int TDatabaseHighDynamicRange_3_serialize(
    TDatabaseHighDynamicRange_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseHighDynamicRange_3_reset(TDatabaseHighDynamicRange_3_t *pConfig);

#ifdef __cplusplus
}
#endif
