/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint16_t darkLowerThr;
  uint16_t darkUpperThr;
  bool enable;
  uint16_t motionLowerThr;
  uint16_t motionUpperThr;
} TDatabaseHighDynamicRange_3_2Dol_DeGhost_t;

typedef struct {
  bool enable;

  float ratio[2];
  float transRange[4][2];
  uint8_t colorWeight[3];
  int8_t extendBit[2];

  uint16_t motionWeight[2];
  uint16_t motionLowerThrLs;
  uint16_t motionUpperThrLs;
  uint16_t motionLowerThrLsvs;
  uint16_t motionUpperThrLsvs;
  uint16_t darkLowerThrLs;
  uint16_t darkUpperThrLs;
  uint16_t darkLowerThrLsvs;
  uint16_t darkUpperThrLsvs;

  bool motionEnable[2];
  uint16_t sensorType;
  bool bypass;
  uint16_t bypassSelect;

  LEGACY TDatabaseState_t state;

  LEGACY TDatabaseHighDynamicRange_3_2Dol_DeGhost_t deGhostLs;
  LEGACY TDatabaseHighDynamicRange_3_2Dol_DeGhost_t deGhostLsVs;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED bool isAlreadyEnabled;
  RESERVED bool isRgbirEnabled;
} TDatabaseHighDynamicRange_3_2Dol_t;

int TDatabaseHighDynamicRange_3_2Dol_parse(
    TJsonValue_t *pValue, TDatabaseHighDynamicRange_3_2Dol_t *pConfig);

int TDatabaseHighDynamicRange_3_2Dol_serialize(
    TDatabaseHighDynamicRange_3_2Dol_t *pConfig, TJsonValue_t *pValue);

int TDatabaseHighDynamicRange_3_2Dol_reset(
    TDatabaseHighDynamicRange_3_2Dol_t *pConfig);

#ifdef __cplusplus
}
#endif
