/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint16_t bypassSelect;
  uint8_t colorWeight[3];
  float ratio[3];
  float transRange[6][2];

  uint16_t sensorType;
  uint32_t bls[4];
  uint32_t blsOut[4];
  bool bypass;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];

  RESERVED bool isAlreadyEnabled;
} TDatabaseHighDynamicRange_3_Lite_t;

int TDatabaseHighDynamicRange_3_Lite_parse(
    TJsonValue_t *pValue, TDatabaseHighDynamicRange_3_Lite_t *pConfig);

int TDatabaseHighDynamicRange_3_Lite_serialize(
    TDatabaseHighDynamicRange_3_Lite_t *pConfig, TJsonValue_t *pValue);

int TDatabaseHighDynamicRange_3_Lite_reset(
    TDatabaseHighDynamicRange_3_Lite_t *pConfig);

#ifdef __cplusplus
}
#endif
