/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint16_t mode;
  uint16_t gridWeight[25];
  TDatabaseRectangle_t rectangle;

  uint32_t bin[32];

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseHistogram_2_t;

int TDatabaseHistogram_2_parse(TJsonValue_t *pValue,
                               TDatabaseHistogram_2_t *pConfig);

int TDatabaseHistogram_2_serialize(TDatabaseHistogram_2_t *pConfig,
                                   TJsonValue_t *pValue);

int TDatabaseHistogram_2_reset(TDatabaseHistogram_2_t *pConfig);

int TDatabaseHistogram_2_statistics(TDatabaseHistogram_2_t *pConfig,
                                    TJsonValue_t *pValue);

#ifdef __cplusplus
}
#endif
