/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
  TDatabaseInputType_Rdma,
  TDatabaseInputType_ReTiming,
  TDatabaseInputType_Sensor,

  TDatabaseInputType_Sum,
} TDatabaseInputType_t;

typedef struct {
  uint16_t bayerPattern;
  size_t bufferLength;
  bool enable;
  uint16_t format;
  TDatabaseRectangle_t rectangle;
  uint16_t stitchingMode;

  bool isInitialized;
} TDatabaseInputPath_t;

typedef struct {
  float framerate;
  TDatabaseInputPath_t paths[TDatabaseInputType_Sum];
  TDatabaseInputType_t type;

  bool isInject;
  bool isInjectLive;
  bool isInjectMeta;
  size_t pathIndex;
  bool isRaw;
  bool isRawHdr;
  bool isStream;
} TDatabaseInput_t;

int TDatabaseInput_parse(TJsonValue_t *pValue, TDatabaseInput_t *pConfig);

int TDatabaseInput_serialize(TDatabaseInput_t *pConfig, TJsonValue_t *pValue);

int TDatabaseInput_reset(TDatabaseInput_t *pConfig);

#ifdef __cplusplus
}
#endif
