/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint16_t matrix[4][1089];
  uint16_t xSize[32];
  uint16_t ySize[32];

  LEGACY TDatabaseState_t state;

  // shell
  RESERVED bool isStatistics;
  RESERVED size_t bufferNumber;
  RESERVED TCommonBuffer_t *pBuffers;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseLensShadingCorrection_4_t;

int TDatabaseLensShadingCorrection_4_parse(
    TJsonValue_t *pValue, TDatabaseLensShadingCorrection_4_t *pConfig);

int TDatabaseLensShadingCorrection_4_parse2(
    TCommonBuffer_t *pBuffer, TDatabaseLensShadingCorrection_4_t *pConfig);

int TDatabaseLensShadingCorrection_4_serialize(
    TDatabaseLensShadingCorrection_4_t *pConfig, TJsonValue_t *pValue);

int TDatabaseLensShadingCorrection_4_reset(
    TDatabaseLensShadingCorrection_4_t *pConfig);

#ifdef __cplusplus
}
#endif
