/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint32_t binNum;
  uint32_t bins[256];
} TDatabaseMetaHistBins_t;

typedef struct {
  uint8_t histWinNum;
  TDatabaseWindow_t histRoiWin[25];
  TDatabaseMetaHistBins_t redChannelBins[25];
  TDatabaseMetaHistBins_t grChannelBins[25];
  TDatabaseMetaHistBins_t gbChannelBins[25];
  TDatabaseMetaHistBins_t blueChannelBins[25];
  TDatabaseMetaHistBins_t totalBins[25];
} TDatabaseMetaHist_t;

typedef struct {
  uint8_t meanWinNum;
  TDatabaseWindow_t meanRoiWin[25];
  uint32_t redChannelMean[25];
  uint32_t grChannelMean[25];
  uint32_t gbChannelMean[25];
  uint32_t blueChannelMean[25];
  uint32_t totalMean[25];
} TDatabaseMetaMeanLuma_t;

typedef struct {
  uint8_t modeAwb;
  uint8_t modeAe;
  float maxExposureTime;

  uint32_t chipId;
  uint64_t frameCount;

  float junctionTemperature;
  uint32_t blackLevelPedestal;

  uint8_t exposureNum;
  uint32_t integrationTime[6];

  float sensorAnalogGain[6];
  float sensorDigitalGain[6];
  float wbGain[6][4];
  float dualConvGain[6];

  TDatabaseMetaHist_t histBins[6];
  TDatabaseMetaMeanLuma_t meanLuma[6];

  RESERVED size_t tableIndex;
  RESERVED size_t tableNumber;
} TDatabaseMeta_t;

int TDatabaseMeta_parse(TJsonValue_t *pValue, TDatabaseMeta_t *pConfig);

int TDatabaseMeta_serialize(TDatabaseMeta_t *pConfig, TJsonValue_t *pValue);

int TDatabaseMeta_reset(TDatabaseMeta_t *pConfig);

#ifdef __cplusplus
}
#endif
