/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  uint16_t id;

  struct {
    char bayerPattern[10];
    uint16_t bit;
    uint16_t crop[4];
    uint16_t frames;
    uint16_t height;
    char path[10][256];
    char metadataInfo[256];
    uint16_t startFrame;
    uint16_t width;
  } input;

  bool nrReloc;

  struct {
    uint16_t dumpYuvVideo;
    uint16_t height;
    char jpgFile[256];
    char path[256];
    char videoFile[256];
    uint16_t width;
    char yuvFile[256];
    char format[256];
    uint16_t dataBits;
    uint16_t yuvOrder;
    uint16_t alpha;
  } output;
} TDatabaseMetaDriver_t;

int TDatabaseMetaDriver_reset(TDatabaseMetaDriver_t *pConfig);

#ifdef __cplusplus
}
#endif
