/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
  TDatabaseOutputType_Main,
  TDatabaseOutputType_MetaData,
  TDatabaseOutputType_Raw,
  TDatabaseOutputType_RawHdr,
  TDatabaseOutputType_Self,
  TDatabaseOutputType_Self2,

  TDatabaseOutputType_Sum,
} TDatabaseOutputType_t;

typedef struct {
  uint16_t bayerPattern;
  uint16_t bitsIndex;
  size_t bufferLength;
  bool isCrop;
  TDatabaseRectangle_t cropRectangle;
  bool enable;
  uint16_t format;
  TDatabaseRectangle_t rectangle;

  uint32_t formatV4l2;
  bool isInitialized;
} TDatabaseOutputPath_t;

typedef struct {
  TDatabaseOutputPath_t paths[TDatabaseOutputType_Sum];
  size_t snapshotNumber;

  size_t pathIndex;
} TDatabaseOutput_t;

int TDatabaseOutput_parse(TJsonValue_t *pValue, TDatabaseOutput_t *pConfig);

int TDatabaseOutput_serialize(TDatabaseOutput_t *pConfig, TJsonValue_t *pValue);

int TDatabaseOutput_reset(TDatabaseOutput_t *pConfig);

#ifdef __cplusplus
}
#endif
