/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint8_t correctLChangeDown;
  uint8_t correctLChangeUp;
  uint8_t correctLChannel;
  uint8_t correctLLimitBase;
  uint8_t correctRChangeDown;
  uint8_t correctRChangeUp;
  uint8_t correctRChannel;
  uint8_t correctRLimitBase;
  uint8_t correctThr;
  uint32_t dummyLineHw;
  uint16_t roi[4];

  uint16_t internalPdafBayerPattern;
  uint32_t internalPdafCorrectRect[4];
  uint32_t internalPdafImageHeight;
  uint32_t internalPdafImageWidth;
  uint8_t internalPdafNumPerArea[2];
  uint16_t internalPdafPdArea[4];
  uint16_t internalPdafSensorType;
  bool internalPdafOcl2x1Shield;
  uint8_t internalPdafShiftLr[2];
  uint8_t internalPdafShiftMark[32];

  char bayerPatternName[10];
  bool correctEn;
  // int pdFocalHeight;
  // int pdFocalWidth;
  uint8_t pix00ShiftHw[2];
  char sensorTypeName[20];

  DEPRECATED_MSG("use internalPdafOcl2x1Shield instead") bool oclShield;

  LEGACY TDatabaseState_t state;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabasePhaseDetectionAutoFocus_t;

int TDatabasePhaseDetectionAutoFocus_parse(
    TJsonValue_t *pValue, TDatabasePhaseDetectionAutoFocus_t *pConfig);

int TDatabasePhaseDetectionAutoFocus_serialize(
    TDatabasePhaseDetectionAutoFocus_t *pConfig, TJsonValue_t *pValue);

int TDatabasePhaseDetectionAutoFocus_reset(
    TDatabasePhaseDetectionAutoFocus_t *pConfig);

int TDatabasePhaseDetectionAutoFocus_dataChanged(
    TDatabasePhaseDetectionAutoFocus_t *pConfig);

#ifdef __cplusplus
}
#endif
