/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2023 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
  TDatabaseRegisterType_Isp,
  TDatabaseRegisterType_Sensor
} TDatabaseRegisterType_t;

typedef struct {
  char address[10];
  bool isReadAction;
  TDatabaseRegisterType_t type;
  char value[10];
} TDatabaseRegister_t;

int TDatabaseRegister_parse(TJsonValue_t *pValue, TDatabaseRegister_t *pConfig);

int TDatabaseRegister_serialize(TDatabaseRegister_t *pConfig,
                                TJsonValue_t *pValue);

int TDatabaseRegister_reset(TDatabaseRegister_t *pConfig);

#ifdef __cplusplus
}
#endif
