/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Li, Renji since 2024 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  float ccMatrix[12];
  uint16_t dpccMidTh[4];
  uint16_t dpccTh[4];
  uint32_t irThr;
  uint32_t lThr;

  uint32_t bls[4];
  uint16_t irBayerPattern;
  uint16_t outRgbPattern;

  LEGACY TDatabaseState_t state;

  RESERVED bool isAlreadyEnabled;

  // simulator section
  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseRgbInfraredRadiation_1_1_t;

int TDatabaseRgbInfraredRadiation_1_1_parse(
    TJsonValue_t *pValue, TDatabaseRgbInfraredRadiation_1_1_t *pConfig);

int TDatabaseRgbInfraredRadiation_1_1_serialize(
    TDatabaseRgbInfraredRadiation_1_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseRgbInfraredRadiation_1_1_reset(
    TDatabaseRgbInfraredRadiation_1_1_t *pConfig);

#ifdef __cplusplus
}
#endif
