/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  uint32_t xBit;
  uint32_t yBit;
} TDatabaseSensor_Compress_t;

typedef struct {
  bool enable;
  uint16_t type;
} TDatabaseSensor_TestPattern_t;

typedef enum {
  TDatabaseSensor_Type_Linear,
  TDatabaseSensor_Type_StitchingHdr,
  TDatabaseSensor_Type_NativeHdr,
} TDatabaseSensor_Type_t;

typedef struct {
  uint16_t autoFocusMode;
  uint16_t bayerPattern;
  uint32_t bitWidth;
  TDatabaseSensor_Compress_t compress;
  uint16_t fpsMax;
  uint16_t nativeMode;
  TDatabaseRectangle_t rectangle;
  uint16_t stitchingMode;
  TDatabaseSensor_Type_t type;
} TDatabaseSensor_Mode_t;

typedef struct {
  uint32_t index;
  uint32_t width;
  uint32_t height;
  int32_t sensorType;
  int32_t stitchingMode;
  int32_t nativeMode;
  uint32_t bitWidth;
  int32_t bayerPattern;
  uint32_t maxFps;
  int32_t afMode;
  int32_t dataType;
  int32_t itfType;
} TDatabaseSensor_DrvModeInfo_t;

typedef struct {
  uint32_t number;
  char name[20];
  TDatabaseSensor_DrvModeInfo_t drvModeInfos[12];
} TDatabaseSensor_ListInfo_t;

typedef struct {
  uint32_t chipId;
  char name[20];
} TDatabaseSensor_ConnectPortInfo_t;

typedef struct {
  uint16_t modeIdx;
  size_t modeNumber;
  TDatabaseSensor_Mode_t modes[12];
  char driverName[20];
  TJsonValue_t *pJQuery;
  TDatabaseSensor_TestPattern_t testPattern;

  uint16_t listInfoNumber;
  TDatabaseSensor_ListInfo_t listInfos[20];

  uint16_t connectPortInfoNumber;
  TDatabaseSensor_ConnectPortInfo_t connectPortInfos[2];

  // simulator section
  char class_[T_DATABASE_CLASS_NAME_LENGTH];
  bool enable;

  char driverNameCurrent[20];
} TDatabaseSensor_t;

int TDatabaseSensor_parse(TJsonValue_t *pValue, TDatabaseSensor_t *pConfig);

int TDatabaseSensor_serialize(TDatabaseSensor_t *pConfig, TJsonValue_t *pValue);

int TDatabaseSensor_reset(TDatabaseSensor_t *pConfig);

#ifdef __cplusplus
}
#endif
