/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
  TDatabaseSettingProtocol_Simulator,
  TDatabaseSettingProtocol_Standard
} TDatabaseSettingProtocol_t;

typedef struct {
  bool isReset;
  TDatabaseSettingProtocol_t protocol;

  size_t bufferNumber;
  TCommonBuffer_t *pBuffers;
} TDatabaseSetting_t;

int TDatabaseSetting_parse(TJsonValue_t *pValue, TDatabaseSetting_t *pConfig);

int TDatabaseSetting_serialize(TDatabaseSetting_t *pConfig,
                               TJsonValue_t *pValue);

int TDatabaseSetting_reset(TDatabaseSetting_t *pConfig);

#ifdef __cplusplus
}
#endif
