/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2024 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  uint8_t blockFrames;
  uint16_t bufSize;
  uint32_t bwl;
  uint32_t ecc;
  int32_t irqMode;
  int32_t parity;
  int32_t ppc;
} TDatabaseVi200_Channel_t;

typedef struct {
  uint16_t blankH;
  uint16_t blankV;
  uint16_t rtBpH;
  uint16_t rtBpV;
  uint16_t rtFpH;
  uint16_t rtFpV;
  uint16_t rtSaH;
  uint16_t rtSaV;
  uint16_t startX;
  uint16_t startY;
} TDatabaseVi200_Property_t;

typedef struct {
  TDatabaseVi200_Channel_t channel;
  int32_t dvpId;
  bool enable;
  TDatabaseVi200_Property_t property;
} TDatabaseVi200_t;

int TDatabaseVi200_parse(TJsonValue_t *pValue, TDatabaseVi200_t *pConfig);

int TDatabaseVi200_serialize(TDatabaseVi200_t *pConfig, TJsonValue_t *pValue);

int TDatabaseVi200_reset(TDatabaseVi200_t *pConfig);

#ifdef __cplusplus
}
#endif
