/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  int16_t contrast;
  uint8_t globalStrength;
  uint8_t highStrength;
  uint8_t lowStrength;
  uint8_t strength;

  uint8_t flatStrength;
  uint8_t flatThr;

  int16_t entropyBase;
  int16_t entropySlope;
  uint32_t entropy[20];

  uint32_t gammaDown[20];
  uint32_t gammaPre[20];
  uint32_t gammaUp[20];

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseWideDynamicRange_4_1_t;

int TDatabaseWideDynamicRange_4_1_parse(
    TJsonValue_t *pValue, TDatabaseWideDynamicRange_4_1_t *pConfig);

int TDatabaseWideDynamicRange_4_1_serialize(
    TDatabaseWideDynamicRange_4_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseWideDynamicRange_4_1_reset(
    TDatabaseWideDynamicRange_4_1_t *pConfig);

#ifdef __cplusplus
}
#endif
