/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool gCurveEnable;

  uint8_t strengthCfgStrength;
  uint8_t strengthCfgHighStrength;
  uint16_t strengthCfgLowStrength;

  int16_t ltmWeightCfgContrast;
  bool ltmWeightCfgEntropyEnable;
  uint16_t ltmWeightCfgEntropyBase;
  uint16_t ltmWeightCfgEntropySlope;
  uint16_t ltmWeightCfgWdrLumaThr;

  bool ltmCfgFlatMode;
  uint8_t ltmCfgFlatLevel;
  uint8_t ltmCfgFlatLevelInc[4][17];
  uint8_t ltmCfgDarkAttentionLevel;

  uint16_t gtmWeightCfgFixedWeight;

  uint8_t gtmCfgWdrCurveSelect;
  uint8_t gtmCfgLogWeight;
  float gtmCfgLogAnchorXLog;
  uint16_t gtmCfgLogAnchorSlope;
  float gtmCfgRatioActual;
  float gtmCfgCurve2Thr;
  float gtmCfgCurve2LoSat;
  float gtmCfgCurve2LoFactor;
  float gtmCfgCurve2HiFactor;
  uint8_t gtmCfgFlatLevelGlobal;

  float degammaCfgdeGamma;

  uint16_t gainLimitCfgMaxGain;
  uint16_t gainLimitCfgMinGain;

  float defringeCfgDiffHigh;
  float defringeCfgDiffLow;

  float satAdjustCfgSatRange;
  uint16_t satAdjustCfgSatThrGainDown;
  uint16_t satAdjustCfgSatThrGainUp;

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseWideDynamicRange_5_1_t;

int TDatabaseWideDynamicRange_5_1_parse(
    TJsonValue_t *pValue, TDatabaseWideDynamicRange_5_1_t *pConfig);

int TDatabaseWideDynamicRange_5_1_serialize(
    TDatabaseWideDynamicRange_5_1_t *pConfig, TJsonValue_t *pValue);

int TDatabaseWideDynamicRange_5_1_reset(
    TDatabaseWideDynamicRange_5_1_t *pConfig);

#ifdef __cplusplus
}
#endif
