/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;
  bool lightEn;

  uint8_t strengthCfgStrength;
  uint8_t strengthCfgHighStrength;
  uint16_t strengthCfgLowStrength;

  int16_t ltmWeightCfgContrast;
  bool ltmWeightCfgEntropyEnable;
  uint16_t ltmWeightCfgEntropyBase;
  uint16_t ltmWeightCfgEntropySlope;
  uint16_t ltmWeightCfgWdrLumaThr;

  bool ltmCfgFlatMode;
  uint8_t ltmCfgFlatLevel;
  uint8_t ltmCfgFlatLevelInc[4][17];
  uint8_t ltmCfgDarkAttentionLevel;

  uint16_t gtmWeightCfgFixedWeight;

  uint8_t gtmCfgWdrCurveSelect;
  uint8_t gtmCfgLogWeight;
  float gtmCfgLogAnchorXLog;
  uint16_t gtmCfgLogAnchorSlope;
  float gtmCfgRatioActual;
  float gtmCfgCurve2Thr;
  float gtmCfgCurve2LoSat;
  float gtmCfgCurve2LoFactor;
  float gtmCfgCurve2HiFactor;
  uint8_t gtmCfgFlatLevelGlobal;

  float degammaCfgdeGamma;

  uint16_t gainLimitCfgMaxGain;
  uint16_t gainLimitCfgMinGain;

  float defringeCfgDiffHigh;
  float defringeCfgDiffLow;

  float satAdjustCfgSatRange;
  uint16_t satAdjustCfgSatThrGainDown;
  uint16_t satAdjustCfgSatThrGainUp;

  uint8_t haloColCfgLightSatLoThr;
  uint8_t haloColCfgLightSatHiThr;
  float haloColCfgLightRedThrLog[4];
  float haloColCfgLightGreenThrLog[4];
  float haloColCfgLightBlueThrLog[4];
  float haloColCfgLightYellowThrLog[4];
  float haloColCfgLightCyanThrLog[4];
  float haloColCfgLightMagentaThrLog[4];

  float highLightCfgBaseLog;
  uint8_t highLightCfgSlope;

  uint8_t dampCfgDampMode;
  uint8_t dampCfgDampCurveCoef;
  uint8_t dampCfgDampCurveMax;
  uint8_t dampCfgDampCurveMin;
  uint8_t dampCfgDampAvgCoef;
  uint8_t dampCfgDampAvgMax;
  uint8_t dampCfgDampAvgMin;
  uint8_t dampCfgDampCoefDecLimit;
  uint8_t dampCfgDampCoefIncLimit;
  uint8_t dampCfgDampFilterSize;
  float dampCfgDampHiThrLog;
  float dampCfgDampLoThrLog;

  uint8_t colorWeiCfgWdrRgbCoef[3];
  uint8_t colorWeiCfgWdrLightnessWeight;
  uint8_t colorWeiCfgWdrColorWeight[3];

  uint32_t gammaUpCurveX[65];
  uint32_t gammaUpCurveY[65];

  LEGACY TDatabaseState_t state;

  DEPRECATED_MSG("use strengthCfgStrength instead") uint8_t strength;
  DEPRECATED_MSG("use strengthCfgHighStrength instead") uint8_t highStrength;
  DEPRECATED_MSG("use strengthCfgLowStrength instead") uint16_t lowStrength;

  DEPRECATED_MSG("use ltmWeightCfgContrast instead") int16_t contrast;
  DEPRECATED_MSG("use ltmWeightCfgEntropyEnable instead") bool entropyEnable;
  DEPRECATED_MSG("use ltmWeightCfgEntropyBase instead") uint16_t entropyBase;
  DEPRECATED_MSG("use ltmWeightCfgEntropySlope instead") uint16_t entropySlope;
  DEPRECATED_MSG("use ltmWeightCfgWdrLumaThr instead") uint16_t wdrLumaThr;

  DEPRECATED_MSG("use ltmCfgFlatMode instead") bool flatMode;
  DEPRECATED_MSG("use ltmCfgFlatLevel instead") uint8_t flatLevel;
  DEPRECATED_MSG("use ltmCfgFlatLevelInc instead") uint8_t flatLevelInc[4][17];
  DEPRECATED_MSG("use ltmCfgDarkAttentionLevel instead")
  uint8_t darkAttentionLevel;

  DEPRECATED_MSG("use gtmWeightCfgFixedWeight instead") uint16_t fixedWeight;

  DEPRECATED_MSG("use gtmCfgWdrCurveSelect instead") uint8_t wdrCurveSelect;
  DEPRECATED_MSG("use gtmCfgLogWeight instead") uint8_t logWeight;
  DEPRECATED_MSG("use gtmCfgLogAnchorXLog instead") float logAnchorXLog;
  DEPRECATED_MSG("use gtmCfgLogAnchorSlope instead") uint16_t logAnchorSlope;
  DEPRECATED_MSG("use gtmCfgRatioActual instead") float ratioActual;
  DEPRECATED_MSG("use gtmCfgCurve2Thr instead") float curve2Thr;
  DEPRECATED_MSG("use gtmCfgCurve2LoSat instead") float curve2LoSat;
  DEPRECATED_MSG("use gtmCfgCurve2LoFactor instead") float curve2LoFactor;
  DEPRECATED_MSG("use gtmCfgCurve2HiFactor instead") float curve2HiFactor;
  DEPRECATED_MSG("use gtmCfgFlatLevelGlobal instead") uint8_t flatLevelGlobal;

  DEPRECATED_MSG("use degammaCfgdeGamma instead") float deGamma;

  DEPRECATED_MSG("use gainLimitCfgMaxGain instead") uint16_t maxGain;
  DEPRECATED_MSG("use gainLimitCfgMinGain instead") uint16_t minGain;

  DEPRECATED_MSG("use defringeCfgDiffHigh instead") float diffHigh;
  DEPRECATED_MSG("use defringeCfgDiffLow instead") float diffLow;

  DEPRECATED_MSG("use satAdjustCfgSatRange instead") float satRange;
  DEPRECATED_MSG("use satAdjustCfgSatThrGainDown instead")
  uint16_t satThrGainDown;
  DEPRECATED_MSG("use satAdjustCfgSatThrGainUp instead") uint16_t satThrGainUp;

  DEPRECATED_MSG("use haloColCfgLightSatLoThr instead")
  uint8_t lightSatLoThr;
  DEPRECATED_MSG("use haloColCfgLightSatHiThr instead")
  uint8_t lightSatHiThr;
  DEPRECATED_MSG("use haloColCfgLightRedThrLog instead")
  float lightRedThrLog[4];
  DEPRECATED_MSG("use haloColCfgLightGreenThrLog instead")
  float lightGreenThrLog[4];
  DEPRECATED_MSG("use haloColCfgLightBlueThrLog instead")
  float lightBlueThrLog[4];
  DEPRECATED_MSG("use haloColCfgLightYellowThrLog instead")
  float lightYellowThrLog[4];
  DEPRECATED_MSG("use haloColCfgLightCyanThrLog instead")
  float lightCyanThrLog[4];
  DEPRECATED_MSG("use haloColCfgLightMagentaThrLog instead")
  float lightMagentaThrLog[4];

  DEPRECATED_MSG("use highLightCfgBaseLog instead") float hlcBaseLog;
  DEPRECATED_MSG("use highLightCfgSlope instead") uint8_t hlcSlope;

  DEPRECATED_MSG("use dampCfgDampMode instead") uint8_t dampMode;
  DEPRECATED_MSG("use dampCfgDampCurveCoef instead") uint8_t dampCurveCoef;
  DEPRECATED_MSG("use dampCfgDampCurveMax instead") uint8_t dampCurveMax;
  DEPRECATED_MSG("use dampCfgDampCurveMin instead") uint8_t dampCurveMin;
  DEPRECATED_MSG("use dampCfgDampAvgCoef instead") uint8_t dampAvgCoef;
  DEPRECATED_MSG("use dampCfgDampAvgMax instead") uint8_t dampAvgMax;
  DEPRECATED_MSG("use dampCfgDampAvgMin instead") uint8_t dampAvgMin;
  DEPRECATED_MSG("use dampCfgDampCoefDecLimit instead")
  uint8_t dampCoefDecLimit;
  DEPRECATED_MSG("use dampCfgDampCoefIncLimit instead")
  uint8_t dampCoefIncLimit;
  DEPRECATED_MSG("use dampCfgDampFilterSize instead") uint8_t dampFilterSize;
  DEPRECATED_MSG("use dampCfgDampHiThrLog instead") float dampHiThrLog;
  DEPRECATED_MSG("use dampCfgDampLoThrLog instead") float dampLoThrLog;

  DEPRECATED_MSG("use colorWeiCfgWdrRgbCoef instead") uint8_t wdrRgbCoef[3];
  DEPRECATED_MSG("use colorWeiCfgWdrLightnessWeight instead")
  uint8_t wdrLightnessWeight;
  DEPRECATED_MSG("use colorWeiCfgWdrColorWeight instead")
  uint8_t wdrColorWeight[3];

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseWideDynamicRange_5_2_t;

int TDatabaseWideDynamicRange_5_2_parse(
    TJsonValue_t *pValue, TDatabaseWideDynamicRange_5_2_t *pConfig);

int TDatabaseWideDynamicRange_5_2_serialize(
    TDatabaseWideDynamicRange_5_2_t *pConfig, TJsonValue_t *pValue);

int TDatabaseWideDynamicRange_5_2_reset(
    TDatabaseWideDynamicRange_5_2_t *pConfig);

#ifdef __cplusplus
}
#endif
