/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#include "database_base.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  bool enable;

  uint8_t strength;
  uint8_t highStrength;
  uint16_t lowStrength;

  int16_t contrast;
  bool entropyEnable;
  uint16_t entropyBase;
  uint16_t entropySlope;
  uint16_t wdrLumaThr;

  bool flatMode;
  uint8_t flatLevel;
  uint8_t flatLevelInc[4][17];
  uint8_t darkAttentionLevel;

  uint16_t fixedWeight;

  uint8_t wdrCurveSelect;
  uint8_t logWeight;
  float logAnchorXLog;
  uint16_t logAnchorSlope;
  float ratioActual;
  float curve2Thr;
  float curve2LoSat;
  float curve2LoFactor;
  float curve2HiFactor;
  uint8_t flatLevelGlobal;

  float deGamma;

  uint16_t maxGain;
  uint16_t minGain;

  float diffHigh;
  float diffLow;

  float satRange;
  uint16_t satThrGainDown;
  uint16_t satThrGainUp;

  uint8_t lightSatLoThr;
  uint8_t lightSatHiThr;
  float lightRedThrLog[4];
  float lightGreenThrLog[4];
  float lightBlueThrLog[4];
  float lightYellowThrLog[4];
  float lightCyanThrLog[4];
  float lightMagentaThrLog[4];

  float hlcBaseLog;
  uint8_t hlcSlope;

  bool lightEn;

  uint8_t dampMode;
  uint8_t dampCurveCoef;
  uint8_t dampCurveMax;
  uint8_t dampCurveMin;
  uint8_t dampAvgCoef;
  uint8_t dampAvgMax;
  uint8_t dampAvgMin;
  uint8_t dampCoefDecLimit;
  uint8_t dampCoefIncLimit;
  uint8_t dampFilterSize;
  float dampHiThrLog;
  float dampLoThrLog;

  uint8_t wdrRgbCoef[3];
  uint8_t wdrLightnessWeight;
  uint8_t wdrColorWeight[3];

  uint32_t gammaUpCurveX[65];
  uint32_t gammaUpCurveY[65];

  LEGACY TDatabaseState_t state;

  RESERVED bool isStatistics;

  SIMULATOR char class_[T_DATABASE_CLASS_NAME_LENGTH];
} TDatabaseWideDynamicRange_5_3_t;

int TDatabaseWideDynamicRange_5_3_parse(
    TJsonValue_t *pValue, TDatabaseWideDynamicRange_5_3_t *pConfig);

int TDatabaseWideDynamicRange_5_3_serialize(
    TDatabaseWideDynamicRange_5_3_t *pConfig, TJsonValue_t *pValue);

int TDatabaseWideDynamicRange_5_3_reset(
    TDatabaseWideDynamicRange_5_3_t *pConfig);

#ifdef __cplusplus
}
#endif
