/******************************************************************************\
|* Copyright (c) <2022> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* Powered by Yang, Yong since 2022 */

#pragma once

#define PROJECT_NAME_TUNING_DATABASE "t_database_c"
#define PROJECT_VERSION_TUNING_DATABASE "6.1.0"
#define PROJECT_TIME_TUNING_DATABASE "2025-06-09 14-43-28"

#include <t_common.h>
#include <t_json.h>

#if defined(TUNE_EDITION_OPTION_XML)
#include <mxml.h>
#endif // TUNE_EDITION_OPTION_XML

#define TUNE_ISP_VERSION "ISP8000_V2107"

#define TUNE_UNITS_SENSOR "ov2775"

/* #undef T_DATABASE_2D_NOISE_REDUCTION_3 */
/* #undef T_DATABASE_2D_NOISE_REDUCTION_5_2 */
/* #undef T_DATABASE_2D_NOISE_REDUCTION_6 */
#define T_DATABASE_3A_INTERFACE_2 "3AI_2"
/* #undef T_DATABASE_3D_NOISE_REDUCTION_1_2 */
/* #undef T_DATABASE_3D_NOISE_REDUCTION_2_1 */
/* #undef T_DATABASE_3D_NOISE_REDUCTION_2_4 */
/* #undef T_DATABASE_3D_NOISE_REDUCTION_3 */
#define T_DATABASE_3D_NOISE_REDUCTION_3_1 "3DNR_3_1"
/* #undef T_DATABASE_3D_NOISE_REDUCTION_4 */
#define T_DATABASE_BLACK_LEVEL_SUBTRACTION "BLS"
#define T_DATABASE_C_MODEL "C_MODEL"
#define T_DATABASE_CALIBRATION "CLB"
/* #undef T_DATABASE_COLOR_CORRECTION_MATRIX */
#define T_DATABASE_COLOR_CORRECTION_MATRIX_1_1 "CCM_1_1"
/* #undef T_DATABASE_COLOR_CORRECTION_WHITE_PIXEL */
/* #undef T_DATABASE_COLOR_NOISE_REDUCTION */
/* #undef T_DATABASE_COLOR_NOISE_REDUCTION_2_1 */
/* #undef T_DATABASE_COLOR_NOISE_REDUCTION_2_2 */
#define T_DATABASE_COLOR_PROCESS_1_2 "CP_1_2"
/* #undef T_DATABASE_COLOR_SPACE_MATRIX */
#define T_DATABASE_COMPAND_1_1 "CPD_1_1"
#define T_DATABASE_DEFECT_PIXEL_CLUSTER_CORRECTION "DPCC"
/* #undef T_DATABASE_DEMOSAIC_1_1 */
#define T_DATABASE_DEMOSAIC_2 "DMSC_2"
/* #undef T_DATABASE_DEMOSAIC_3 */
#define T_DATABASE_DENOISE_PREFILTER "DPF"
#define T_DATABASE_DEVICE "DVC"
#define T_DATABASE_DIGITAL_GAIN "DG"
#define T_DATABASE_DUMP "DUMP"
/* #undef T_DATABASE_DYNAMIC_CONTRAST_IMPROVEMENT_HISTOGRAM */
/* #undef T_DATABASE_EDGE_ENHANCE */
#define T_DATABASE_EDGE_ENHANCE_2 "EE_2"
/* #undef T_DATABASE_EDGE_ENHANCE_3 */
#define T_DATABASE_EXPOSURE_CONTROL_2 "EC_2"
#define T_DATABASE_FOCUS_CONTROL "FC"
/* #undef T_DATABASE_GAMMA_CORRECTION */
#define T_DATABASE_GAMMA_CORRECTION_2 "GC_2"
/* #undef T_DATABASE_GLOBAL_TONE_MAPPING */
/* #undef T_DATABASE_GLOBAL_WIDE_DYNAMIC_RANGE */
#define T_DATABASE_GREEN_EQUILIBRATION "GE"
/* #undef T_DATABASE_GREEN_EQUILIBRATION_2 */
/* #undef T_DATABASE_HIGH_DYNAMIC_RANGE_1_3 */
/* #undef T_DATABASE_HIGH_DYNAMIC_RANGE_2 */
#define T_DATABASE_HIGH_DYNAMIC_RANGE_2_1 "HDR_2_1"
/* #undef T_DATABASE_HIGH_DYNAMIC_RANGE_2_1_2DOL */
/* #undef T_DATABASE_HIGH_DYNAMIC_RANGE_3 */
/* #undef T_DATABASE_HIGH_DYNAMIC_RANGE_3_2DOL */
/* #undef T_DATABASE_HIGH_DYNAMIC_RANGE_3_LITE */
/* #undef T_DATABASE_HISTOGRAM */
/* #undef T_DATABASE_HISTOGRAM_2 */
#define T_DATABASE_INPUT "IPT"
#define T_DATABASE_ISP "ISP"
/* #undef T_DATABASE_LENS_SHADING_CORRECTION */
/* #undef T_DATABASE_LENS_SHADING_CORRECTION_2 */
#define T_DATABASE_LENS_SHADING_CORRECTION_3 "LSC_3"
/* #undef T_DATABASE_LENS_SHADING_CORRECTION_4 */
/* #undef T_DATABASE_LENS_SHADING_CORRECTION_WHITE_PIXEL */
/* #undef T_DATABASE_LOOK_UP_TABLE_3D */
#define T_DATABASE_META "MT"
#define T_DATABASE_META_DRIVER "MD"
#define T_DATABASE_MISC "MISC"
#define T_DATABASE_OUTPUT "OPT"
/* #undef T_DATABASE_PHASE_DETECTION_AUTO_FOCUS */
#define T_DATABASE_REPORT "RPT"
#define T_DATABASE_REGISTER "RGT"

#if defined(TUNE_EDITION_OPTION_SENSOR_IR)
/* #undef T_DATABASE_RGB_INFRARED_RADIATION */
/* #undef T_DATABASE_RGB_INFRARED_RADIATION_1_1 */
/* #undef T_DATABASE_RGB_INFRARED_RADIATION_2 */
/* #undef T_DATABASE_RGB_INFRARED_RADIATION_2_1 */
#endif // TUNE_EDITION_OPTION_SENSOR_IR

#define T_DATABASE_SENSOR "SS"
#define T_DATABASE_SETTING "ST"
#define T_DATABASE_TILE "TL"
#define T_DATABASE_TRANSMIT "TM"

#if defined(TUNE_EDITION_OPTION_VI200)
/* #undef T_DATABASE_VI200 */
/* #undef T_DATABASE_VI200_2 */
/* #undef T_DATABASE_VI200_2_1 */
/* #undef T_DATABASE_VI200_2_2 */
#endif // TUNE_EDITION_OPTION_VI200

/* #undef T_DATABASE_WHITE_BALANCE */
#define T_DATABASE_WHITE_BALANCE_1_1 "WB_1_1"
/* #undef T_DATABASE_WIDE_DYNAMIC_RANGE_3_1 */
#define T_DATABASE_WIDE_DYNAMIC_RANGE_4_1 "WDR_4_1"
/* #undef T_DATABASE_WIDE_DYNAMIC_RANGE_5 */
/* #undef T_DATABASE_WIDE_DYNAMIC_RANGE_5_1 */
/* #undef T_DATABASE_WIDE_DYNAMIC_RANGE_5_2 */
/* #undef T_DATABASE_WIDE_DYNAMIC_RANGE_5_2_1 */
/* #undef T_DATABASE_WIDE_DYNAMIC_RANGE_5_3 */

/* #undef T_DATABASE_AUTO_2D_NOISE_REDUCTION_3 */
/* #undef T_DATABASE_AUTO_2D_NOISE_REDUCTION_5_2 */
/* #undef T_DATABASE_AUTO_2D_NOISE_REDUCTION_6 */
/* #undef T_DATABASE_AUTO_3D_NOISE_REDUCTION_1_2 */
/* #undef T_DATABASE_AUTO_3D_NOISE_REDUCTION_2_1 */
/* #undef T_DATABASE_AUTO_3D_NOISE_REDUCTION_2_4 */
/* #undef T_DATABASE_AUTO_3D_NOISE_REDUCTION_3 */
#define T_DATABASE_AUTO_3D_NOISE_REDUCTION_3_1 "A3DNR_3_1"
/* #undef T_DATABASE_AUTO_3D_NOISE_REDUCTION_4 */
#define T_DATABASE_AUTO_BLACK_LEVEL_SUBTRACTION "ABLS"
/* #undef T_DATABASE_AUTO_COLOR_CORRECTION_MATRIX */
#define T_DATABASE_AUTO_COLOR_CORRECTION_MATRIX_1_1 "ACCM_1_1"
/* #undef T_DATABASE_AUTO_COLOR_NOISE_REDUCTION_2_1 */
/* #undef T_DATABASE_AUTO_COLOR_NOISE_REDUCTION_2_2 */
#define T_DATABASE_AUTO_COLOR_PROCESS_1_2 "ACP_1_2"
#define T_DATABASE_AUTO_DEFECT_PIXEL_CLUSTER_CORRECTION "ADPCC"
#define T_DATABASE_AUTO_DEMOSAIC_2 "ADMSC_2"
/* #undef T_DATABASE_AUTO_DEMOSAIC_3 */
#define T_DATABASE_AUTO_DENOISE_PREFILTER "ADPF"
/* #undef T_DATABASE_AUTO_EDGE_ENHANCE */
#define T_DATABASE_AUTO_EDGE_ENHANCE_2 "AEE_2"
/* #undef T_DATABASE_AUTO_EDGE_ENHANCE_3 */
#define T_DATABASE_AUTO_EXPOSURE_3 "AE_3"
/* #undef T_DATABASE_AUTO_EXPOSURE_4 */
/* #undef T_DATABASE_AUTO_EXPOSURE_MEASUREMENT_2 */
#define T_DATABASE_AUTO_EXPOSURE_STATISTICS_2 "AES_2"
/* #undef T_DATABASE_AUTO_EXPOSURE_STATISTICS_3 */
#define T_DATABASE_AUTO_FOCUS_3 "AF_3"
/* #undef T_DATABASE_AUTO_FOCUS_4 */
#define T_DATABASE_AUTO_FOCUS_MEASUREMENT "AFM"
/* #undef T_DATABASE_AUTO_FOCUS_MEASUREMENT_1_1 */
/* #undef T_DATABASE_AUTO_FOCUS_MEASUREMENT_3 */
#define T_DATABASE_AUTO_GAMMA_CORRECTION_2 "AGC_2"
/* #undef T_DATABASE_AUTO_GLOBAL_TONE_MAPPING */
/* #undef T_DATABASE_AUTO_HIGH_DYNAMIC_RANGE */
/* #undef T_DATABASE_AUTO_HIGH_DYNAMIC_RANGE_3 */
/* #undef T_DATABASE_AUTO_LENS_SHADING_CORRECTION_2 */
#define T_DATABASE_AUTO_LENS_SHADING_CORRECTION_3 "ALSC_3"
/* #undef T_DATABASE_AUTO_LENS_SHADING_CORRECTION_4 */
/* #undef T_DATABASE_AUTO_RGB_INFRARED_RADIATION_2_1 */
#define T_DATABASE_AUTO_WHITE_BALANCE_3 "AWB_3"
/* #undef T_DATABASE_AUTO_WHITE_BALANCE_4 */
#define T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_4_1 "AWDR_4_1"
/* #undef T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_5 */
/* #undef T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_5_1 */
/* #undef T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_5_2 */
/* #undef T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_5_2_1 */
/* #undef T_DATABASE_AUTO_WIDE_DYNAMIC_RANGE_5_3 */
