/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/


#ifndef ISP_RDCD_H
#define ISP_RDCD_H
#ifdef ISP_RDCD
#include "isp_ic_dev.h"
typedef enum rdcd_mi_dma_path_e {
    ISP_RDCD_MI_RAW0 = 0,
    ISP_RDCD_MI_RAW1,
    ISP_RDCD_MI_RAW2,
    ISP_RDCD_MI_RAW3,
    ISP_RDCD_MI_ID_MAX,
} rdcd_mi_dma_path_t;

enum RDCD_IN_RAW_BPT {
    ISP_RDCD_IN_RGGB = 0,
    ISP_RDCD_IN_GRBG,
    ISP_RDCD_IN_GBRG,
    ISP_RDCD_IN_BGGR,
    ISP_RDCD_IN_BPT_MAX,
};


struct isp_rdcd_context {
    PicBufType_t type;
    uint32_t base;
    uint32_t width;
    uint32_t height;
    uint32_t burst_y;
    uint32_t burst_c;
    uint8_t  align;
    uint8_t id;
    uint8_t rd_wr_str;

    bool_t tileMode;
    uint32_t tileWidth;
    uint32_t tileHeight;

    bool_t decmp_enable;
    PicBufLossMode_t loss_mode;
    PicBufRdceType_t bit_depth;
    uint16_t bit_thresh;

    uint16_t target_size;
    PicBufRdceBayerPat_t in_bpt;
    uint32_t crcValue;
};


int32_t isp_ioc_init_rdcd(void *pDev);
int32_t isp_rdcd_s_rdma_cfg(void *dev, void *args);
int32_t isp_rdcd_start_rdma(void *dev, void *args);

#endif
#endif
