/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

/* VeriSilicon 2020 */

/**
 * @file switch_common.h
 *
 * @brief
 *   Common definitions of the Switch.
 *
 *****************************************************************************/
/**
 *
 * @defgroup switch_common Switch Common Definitions
 * @{
 *
 */
#ifndef SWITCH_COMMON_H
#define SWITCH_COMMON_H

#include <oslayer/oslayer.h>
#include <common/return_codes.h>
#ifdef __cplusplus
extern "C"
{
#endif



/*****************************************************************************/
/**
 *  @brief AFPS resolution change request signaling callback
 *
 *  Callback for signaling an AFPS resolution (better: frame rate) change
 *  request to the application.
 *
 *****************************************************************************/
typedef void (*SwitchAfpsResChangeCb_t)
(
    uint32_t            NewResolution,  /**< new resolution to switch to */
    const void          *pUserCbCtx     /**< user data pointer that was passed on creation (see @ref SwitchInstanceConfig_t) */
);


#ifdef __cplusplus
}
#endif


/* @} switch_common */


#endif /* __SWITCH_COMMON_H__ */

