/******************************************************************************\
|* Copyright (c) <2024> by VeriSilicon Holdings Co., Ltd. ("VeriSilicon")     *|
|* All Rights Reserved.                                                       *|
|*                                                                            *|
|* The material in this file is confidential and contains trade secrets       *|
|* of VeriSilicon.  This is proprietary information owned or licensed by      *|
|* VeriSilicon.  No part of this work may be disclosed, reproduced, copied,   *|
|* transmitted, or used in any way for any purpose, without the express       *|
|* written permission of VeriSilicon.                                         *|
|*                                                                            *|
\******************************************************************************/

#ifndef PRIORITYQUEUE_H
#define PRIORITYQUEUE_H

//Define the Node structure
typedef struct node {
    u_int8_t priority;
    u_int8_t id;
    struct node *next;
} Node;


typedef struct {
    Node *head;
    Node *tail;
} PriorityQueue;

void PriorityQueueInit(PriorityQueue *queue) ;
void PriorityQueueDeinit(PriorityQueue *queue);
void PriorityQueueEnqueue(PriorityQueue *queue, u_int8_t priority, u_int8_t id);
u_int8_t PriorityQueueDequeue(PriorityQueue *queue);

void PrintPriorityQueue(const PriorityQueue *queue) ;

#endif /*__PRIORITYQUEUE_H__*/
